#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
using pqg = priority_queue<T, vector<T>, greater<T>>;


//#define int long long
#define fastIo(a) ios_base::sync_with_stdio(a); cin.tie(a); cout.tie(a)
#define all(a) a.begin(), a.end()
#define F first
#define S second
#define sz(a) (int)a.size()

const int INF = 1e9;

vector<vector<bool>> used;
vector<vector<char>> mtx;
const int k = 4;
int dx[k] = {0, 0, -1, 1};
int dy[k] = {1, -1, 0, 0};
int h, w;

void dfs(int y, int x) {
    used[y][x] = true;
    for (int i = 0; i < k; i++) {
        int nx = x + dx[i], ny = y + dy[i];
        if (nx < 0 || nx >= w || ny < 0 || ny >= h || used[ny][nx] || mtx[ny][nx] == '#') {
            continue;
        }
        dfs(ny, nx);
    }
}

void solve() {
    cin >> h >> w;
    mtx.resize(h, vector<char>(w));
    used.resize(h, vector<bool>(w));
    for (auto &i : mtx) {
        for (auto &j : i) cin >> j;
    }

    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if ((i == 0 || j == 0 || i == h - 1 || j == w - 1) && mtx[i][j] == '.' && !used[i][j]) {
                dfs(i, j);
            }
        }
    }

    pair<int, int> mn = {INF, INF};
    for (int i = 1; i < h; i++) {
        for (int j = 1; j < w; j++) {
            if (used[i][j] || mtx[i][j] == '#' || mtx[i - 1][j] != '#' || mtx[i][j - 1] != '#') continue;
            if (mn.S > j) mn = {i, j};
        }
    }

    used.assign(h, vector<bool>(w, false));
    queue<pair<int, int>> q;
    vector<vector<pair<int, int>>> pr(h, vector<pair<int, int>>(w));
    mn.F--, mn.S--;
    for (int i = mn.F; i >= 0; i--) used[i][mn.S] = true;
    for (int i = mn.S; i >= 0; i--) used[mn.F][i] = true;

    q.push({mn.F, mn.S + 1});
    pr[mn.F][mn.S + 1] = mn;
    while (!q.empty()) {
        auto [y, x] = q.front();
        q.pop();
        used[y][x] = true;
        if (y == mn.F + 1 && x == mn.S) {
            break;
        }
        for (int i = 0; i < k; i++) {
            int nx = x + dx[i], ny = y + dy[i];
            if (nx >= w || nx < 0 || ny >= h || ny < 0 || used[ny][nx] || mtx[ny][nx] != '#')
                continue;
            pr[ny][nx] = {y, x};
            used[ny][nx] = true;
            q.push({ny, nx});
        }
    }
    vector<vector<char>> ans(h, vector<char>(w, '.'));
    for (int x = mn.S, y = mn.F + 1; x != mn.S || y != mn.F;) {
        ans[y][x] ='#';
        auto [pry, prx] = pr[y][x];
        y = pry;
        x = prx;
    }
    ans[mn.F][mn.S] = '#';
    for (auto &i : ans) {
        for (auto &j : i) cout << j;
        cout << '\n';
    }
}

int32_t main() {
    cout << fixed << setprecision(20);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
