#include <iostream>
#include <iomanip>
#include <vector>
#include <array>

#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

constexpr ll INF = 1e17;

constexpr ll MOD = 1e9 + 7;

vector<vector<pair<ll, ll>>> g;
ll n, m;

vector<ll> len, cnt;

vector<ll> lenA, lenB, cntA, cntB;

void Dij(const ll A) {
	set<pair<ll, ll>> s;
	s.emplace(0, A);
	fill(len.begin(), len.end(), INF);
	fill(cnt.begin(), cnt.end(), 0);
	len[A] = 0;
	cnt[A] = 1;

	while (!s.empty()) {
		auto [w, a] = *s.begin();
		s.erase(s.begin());

		for (auto& [v, b] : g[a]) {
			if (len[b] > w + v) {
				len[b] = w + v;
				cnt[b] = cnt[a];
				s.emplace(len[b], b);
			}
			else if (len[b] == w + v) {
				cnt[b] = (cnt[b] + cnt[a]) % MOD;
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	ll n, m;
	cin >> n >> m;

	ll A, B, L;
	cin >> A >> B >> L;
	--A, --B;

	g.resize(n);
	len.resize(n);
	cnt.resize(n);
	for (ll i = 0; i < m; ++i) {
		ll v, u, w;
		cin >> v >> u >> w;
		--v, --u;
		g[v].emplace_back(w, u);
		g[u].emplace_back(w, v);
	}

	Dij(A);
	lenA = len;
	cntA = cnt;

	Dij(B);
	lenB = len;
	cntB = cnt;

	ll res = 0;

	for (ll i = 0; i < n; ++i) {
		ll sum = 0;
		bool ok = false;
		for (auto& [w, u] : g[i]) {
			if (lenA[i] + w + lenB[u] == lenA[B])
				ok = true;
			if (lenA[i] + w + lenB[u] == L) {
				sum = (sum + cntB[u]) % MOD;
			}
		}
		if (ok) {
			sum = (cntA[i] * sum) % MOD;
			res = (res + sum) % MOD;
		}
	}

	cout << res << '\n';
}