#include <bits/stdc++.h>

using namespace  std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int inf = 2e9 + 1;

const int MAXN = 1e5+1;

struct node {
    int mi, ma;
};

struct segtree {
    vector <node> tree;
    int size;

    node cmb(node a, node b) {
        return {min(a.mi, b.mi), max(a.ma, b.ma)};
    }

    void init(int n) {
        size = 1;
        while (size < n) {
            size *= 2;
        }
        tree.resize(2 * size - 1, {INT_MAX, INT_MIN});
    }

    void build(vector <int>&a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            if (lx < a.size()) {
                tree[x] = {a[lx], a[lx]};
            }
        }
        else {
            int m = (rx + lx) / 2;
            build(a, 2 * x + 1, lx, m);
            build(a, 2 * x + 2, m, rx);
            tree[x] = cmb(tree[2 * x + 1], tree[2 * x + 2]);
        }
    }

    void build(vector <int>&a) {
        init(a.size());
        build(a, 0, 0, size);
    }

    node get(int l, int r, int x, int lx, int rx) {
        if (l >= rx || lx >= r) {
            return {INT_MAX, INT_MIN};
        }
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        int m = (rx + lx) / 2;
        return cmb(get(l, r, 2 * x + 1, lx, m), get(l, r, 2 * x + 2, m, rx));
    }

    node get(int l, int r) {
        return get(l, r, 0, 0, size);
    }
};

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    vector <int> mid(n/2), hard(n/2), light(n/2);
    for (int i = 0; i < n/2; i++) {
        mid[i] = a[i] + a[n - i - 1];
        hard[i] = a[i] + a[n - i - 2];
        light[i] = a[i + 1] + a[n - i - 1];
    }
    segtree midi, hardi, lighti;
    midi.build(mid);
    hardi.build(hard);
    lighti.build(light);
    int mi = INT_MAX;
    for (int i = 0; i < n; i++) {
        if (i == n / 2 + 1) {
            node ans = midi.get(0, n/2);
            mi = min(mi, ans.ma - ans.mi);
        }
        else if (i < n / 2 + 1) {
            node ans1 = midi.get(0, i);
            node ans2 = lighti.get(i, n/2);
            mi = min(mi, max(ans1.ma, ans2.ma) - min(ans1.mi, ans2.mi));
        }
        else {
            int j = n - i - 1;
            node ans1 = midi.get(0, j);
            node ans2 = hardi.get(j, n/2);
            mi = min(mi, max(ans1.ma, ans2.ma) - min(ans1.mi, ans2.mi));
        }
    }
    cout << mi << "\n";
    return 0;
}
