//77 team
#include <iostream>
#include<algorithm>
#include<cmath>
#include <vector>
#include <queue>
using namespace std;
using ll = long long;
const int INF = 1e9 + 7;
int main()
{
	cin.tie(0)->sync_with_stdio();
	int n, m;
	cin >> n >> m;
	vector<vector<bool>>a(n, vector<bool>(m));
	vector<vector<int>>used(n, vector<int>(m, 1));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char x;
			cin >> x;
			if (x == '#') {
				a[i][j] = 1;
				used[i][j] = -1;
			}
			else a[i][j] = 0;
		}
	}
	
	queue<pair<int, int>>q;
	for (int i = 0; i < n; ++i) {
		if (used[i][0] == 1) {
			q.push({ i, 0 });
			used[i][0] = 0;
		}
		if (used[i][m - 1] == 1) {
			q.push({ i, m-1 });
			used[i][m - 1] = 0;
		}
	}
	for (int j = 0; j < m; ++j) {
		if (used[0][j] == 1) {
			q.push({ 0, j });
			used[0][j] = 0;
		}
		if (used[n-1][j] == 1) {
			q.push({ n-1, j });
			used[n-1][j] = 0;
		}
	}
	while (!q.empty()) {
		auto [x, y] = q.front();
		q.pop();
		if (x + 1 < n and used[x + 1][y] == 1) {
			used[x + 1][y] = 0;
			q.push({ x + 1, y });
		}
		if (x > 0 and used[x - 1][y] == 1) {
			used[x - 1][y] = 0;
			q.push({ x - 1, y });
		}
		if (y + 1 < m and used[x][y+1] == 1) {
			used[x][y+1] = 0;
			q.push({ x, y + 1 });
		}
		if (y>0 and used[x][y-1] == 1) {
			used[x][y-1] = 0;
			q.push({ x, y-1 });
		}
	}
	int lux = INF, luy = INF, rdx = -1, rdy = -1;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (used[i][j] == 1) {
				lux = min(i, lux);
				luy = min(j, luy);
				rdx = max(rdx, i);
				rdy = max(rdy, j);
			}
		}
	}
	--lux;
	--luy;
	++rdx;
	++rdy;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (i == lux and j >= luy and j <= rdy or
				i == rdx and j >= luy and j <= rdy or
				j == luy and i >= lux and i <= rdx or
				j == rdy and i >= lux and i <= rdx)
				cout << "#";
			else cout << ".";
		}
		cout << "\n";
	}

}