#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

using vi = vector<int>;
using vpi = vector<pair<int, int>>;
const long long INF = 2e18;
const long long MOD = 1e9 + 7;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m;
    cin >> n >> m;
    ll s, t, l;
    cin >> s >> t >> l, --s, --t;
    vector<vector<pair<ll, ll>>> g(n);
    for (int i = 0; i < m; ++i) {
        ll x, y, w;
        cin >> x >> y >> w, --x, --y;
        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }
    vector<ll> ds(n, INF);
    vector<ll> dt(n, INF);
    set<pair<ll, ll>> ss;
    set<pair<ll, ll>> st;
    ds[s] = 0;
    dt[t] = 0;
    ss.insert({0, s});
    st.insert({0, t});
    map<pair<ll, ll>, ll> cnts;
    map<pair<ll, ll>, ll> cntt;
    cntt[{0, t}]++;
    cnts[{0, s}]++;
    while (!ss.empty()) {
        auto [q, v] = *ss.begin();
        ss.erase(ss.begin());
        for (auto [u, w]: g[v]) {
            if (ds[v] + w < ds[u]) {
                ss.erase({ds[u], u});
                ds[u] = ds[v] + w;
                cnts[{ds[u], u}]++;
                ss.insert({ds[u], u});
            } else if (ds[v] + w == ds[u]) {
                cnts[{ds[u], u}]++;
            }
        }
    }
    while (!st.empty()) {
        auto [q, v] = *st.begin();
        st.erase(st.begin());
        for (auto [u, w]: g[v]) {
            if (dt[v] + w < dt[u]) {
                st.erase({dt[u], u});
                dt[u] = dt[v] + w;
                cntt[{dt[u], u}]++;
                st.insert({dt[u], u});
            } else if (dt[v] + w == dt[u]) {
                cntt[{dt[u], u}]++;
                cntt[{dt[u], u}] %= MOD;
            }
        }
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        if (ds[i] + dt[i] == ds[t]) {
            for (auto [u, w]: g[i]) {
                if (ds[i] + w + dt[u] == l) {
                    ans += cntt[{dt[u], u}];
                    ans %= MOD;
                }
            }
        }
    }
    cout << ans << "\n";
    return 0;
}
