#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

using ll = long long;

const ll INF = 1e9;
vector<ll> a;


bool no_get_front(ll k) {
    ll mx = a.back() + a[1], mn = a.back() + a[1];
    for (int i = 1, j = a.size() - 1; i < j; ++i, --j) {
        ll now = a[j] + a[i];
        mx = max(mx, now); mn = min(mn, now);
        if (mx - mn > k) return false;
    }
    return true;
}

bool no_get_back(ll k) {
    ll mx = a[a.size() - 2] + a[0], mn = a[a.size() - 2] + a[0];
    for (int i = 0, j = a.size() - 2; i < j; ++i, --j) {
        ll now = a[j] + a[i];
        mx = max(mx, now); mn = min(mn, now);
        if (mx - mn > k) return false;
    }
    return true;
}

bool ok(ll k) {
    if (no_get_front(k)) return true;
    if (no_get_back(k)) return true;


    ll mx = a.back() + a[0], mn = a.back() + a[0];
    if (mx - mn > k) return false;
    bool used = false;
    for (int i = 0, j = a.size() - 1; i < j; ++i, --j) {
        ll now = a[j] + a[i];
        ll tmp_mx = max(mx, now), tmp_mn = min(mn, now);
        if (tmp_mx - tmp_mn > k) {
            if (used) return false;
            else {
                if (now > mx) {
                    --i;
                } else {
                    ++j;
                }
                used = true;
            }
        }
        else {
            mx = tmp_mx; mn = tmp_mn;
        }
    }
    return true;
}


int solve() {
    ll l = -1, r = 2e9;
    while (r - l > 1) {
        ll med = l + (r - l) / 2;
        if (ok(med)) r = med;
        else l = med;
    }
    return r;
}



int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n; cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    cout << solve() << "\n";
    return 0;
}
/*
 5
 1 2 3 5 9
 */
/*
 7
 1 4 7 8 9 10 15
 */