#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <deque>

using namespace std;
using ll = long long;
using ld = long double;

const ll inf = ll(1e18) * 2 + 36;
const int mod = int(1e9) + 7;

#define fast() ios::sync_with_stdio(0); cin.tie(0)
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

struct Edge {
	ll u, v, w;
};

signed main() {
	fast();
	ll n, m;
	cin >> n >> m;
	ll s, f, L; cin >> s >> f >> L;
	s--; f--;
	vector <vector <pair <ll, ll>>> g(n);
	vector <Edge> r;
	while (m--) {
		ll u, v, w; cin >> u >> v >> w; u--; v--;
		g[u].push_back({ v, w });
		g[v].push_back({ u, w });
		r.push_back({ u, v, w });
	}
	vector <ll> df(n), ds(n);
	vector <vector <ll>> prf(n), prs(n);
	vector <ll> kf(n, 1), ks(n, 1);
	df[s] = 0;
	set <pair <ll, ll>> st;
	st.insert({ 0, s });
	while (!st.empty()) {
		auto [v, tmp] = *st.begin();
		st.erase(st.begin());
		for (auto& [u, w] : g[v]) {
			if (df[v] + w < df[u]) {
				st.erase({ df[u], u });
				df[u] = df[v] + w;
				st.insert({ df[u], u });
				prf[u].clear();
				prf[u].push_back(v);
				kf[u] = kf[v];
			}
			else if (df[v] + w == df[u]) {
				prf[u].push_back(v);
				kf[u] = (kf[u] + kf[v]) % mod;
			}
		}
	}
	ds[f] = 0;
	st.insert({ 0, f });
	while (!st.empty()) {
		ll v = st.begin()->first;
		st.erase(st.begin());
		for (auto& it : g[v]) {
			ll u = it.first; ll w = it.second;
			if (ds[v] + w < ds[u]) {
				st.erase({ ds[u], u });
				ds[u] = ds[v] + w;
				st.insert({ ds[u], u });
				prs[u].clear();
				prs[u].push_back(v);
				ks[u] = ks[v];
			}
			else if (ds[v] + w == ds[u]) {
				prs[u].push_back(v);
				ks[u] = (ks[u] + ks[v]) % mod;
			}
		}
	}
	set <ll> t;
	for (auto& i : prf) {
		for (auto& j : i) {
			t.insert(j);
		}
	}
	ll ans = 0;
	for (auto& it : r) {
		ll u = it.u, v = it.v, w = it.w;
		if (t.find(u) == t.end() && t.find(v) != t.end() && df[v] + ds[u] + w == L) {
			ans += kf[v] * ks[u];
		}
		if (t.find(v) == t.end() && t.find(u) != t.end() && df[u] + ds[v] + w == L) {
			ans += kf[u] * ks[v];
		}
	}
	cout << ans + (df[f] == L ? kf[f] : 0);
	return 0;
}