#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <deque>

using namespace std;
using ll = long long;
using ld = long double;
#define int long long
const ll inf = ll(1e18) * 2 + 36;

#define all(x) (x).begin(), (x).end()
#define fast() ios::sync_with_stdio(0); cin.tie(0)
#define rall(x) (x).rbegin(), (x).rend()
struct Node {
	int i = 0;
};
vector<int>tree, p;
void build(int v, int l, int r) {
	if (l == r - 1) {
		tree[v] = l;
		return;
	}
	int mid = (l + r) / 2;
	build(2 * v + 1, l, mid);
	build(2 * v + 2, mid, r);
	tree[v] = (p[tree[2 * v + 1]] <= p[tree[2 * v + 2]] ? tree[2 * v + 1] : tree[2 * v + 2]);
}
int get(int v, int lv, int rv, int l, int r) {
	if (lv >= r || l >= rv) return inf;
	if (l <= lv && rv <= r) return tree[v];
	int mid = (lv + rv) / 2;
	auto t1 = get(2 * v + 1, lv, mid, l, r);
	auto t2 = get(2 * v + 2, mid, rv, l, r);
	if (t1 == inf) return t2;
	if (t2 == inf) return t1;
	return (p[t1] <= p[t2] ? t1 : t2);
}
signed main() {
	fast();
	int n, b, c;
	cin >> n >> b >> c;
	int sz = 1;
	while (sz < n + 1) sz *= 2;
	tree.resize(4 * sz);
	p.resize(4 * sz);
	vector<int>x(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> p[i];
	}
	x.push_back(inf);
	p.push_back(inf);
	n++;
	build(0, 0, sz);
	int i = 0, l = 0, V = 0;
	while (i < n) {
		int v = min(b / p[i], (c - V));
		auto t = upper_bound(x.begin(), x.end(), v + V + x[i]) - x.begin();
		t--;
		if (i != t)
			l = get(0, 0, sz, i + 1, t + 1);
		else {
			cout << x[i] + V + v;
			return 0;
		}
		if (p[l] > p[i]) {
			int u = min(b / p[i], c - V);
			V += u;
			b -= u * p[i];
			V -= (x[l] - x[i]);
			if (V < 0) {
				cout << x[i] + V + (x[l] - x[i]);
				return 0;
			}
			i = l;
		}
		else {
			int u = min({ b / p[i], c - V, x[l] - x[i] });
			V += u;
			b -= u * p[i];
			V -= (x[l] - x[i]);
			if (V < 0) {
				cout << x[i] + V + (x[l] - x[i]);
				return 0;
			}
			i = l;
		}
	}
	return 0;
}