#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <deque>

using namespace std;
using ll = long long;
using ld = long double;

const ll inf = ll(1e18) * 2 + 36;
const int mod = int(1e9) + 7;

#define fast() ios::sync_with_stdio(0); cin.tie(0)
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

struct Edge {
	ll u, v, w;
};

int n, m;
vector<vector<char>>a, ans;
vector<vector<int>>used;
int cnt = 0;
bool f = 1;
void dfs(int i, int j) {
	used[i][j] = cnt;
	if (a[i][j + 1] == '(') {
		f = 1;
	}
	if (a[i + 1][j] == '(') {
		f = 1;
		
	}
	if (a[i][j - 1] == '(') {
		f = 1;
		
	}
	if (a[i - 1][j] == '(') {
		f = 1;
		
	}
	if (a[i][j + 1] != '#' && !used[i][j + 1] && a[i][j + 1] != '(') {
		dfs(i, j + 1);
	}
	if (a[i + 1][j] != '#' && !used[i + 1][j] && a[i + 1][j] != '(') {
		dfs(i + 1, j);
	}
	if (a[i][j - 1] != '#' && !used[i][j - 1] && a[i][j - 1] != '(') {
		dfs(i, j - 1);
	}
	if (a[i - 1][j] != '#' && !used[i - 1][j] && a[i - 1][j] != '(') {
		dfs(i - 1, j);
	}
}
signed main() {
	fast();
	cin >> n >> m;
	a.resize(n + 5, vector<char>(m + 5, '('));
	used.resize(n + 5, vector<int>(m + 5));
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			cin >> a[i][j];
		}
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			if (!used[i][j]) {
				if (a[i][j] == '#') continue;
				f = 0;
				cnt++;
				dfs(i, j);
				if (!f) break;
			}
		}
		if (!f) break;
	}

	/*for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			cout << used[i][j];
		}
		cout << '\n';
	}*/

	int verxi = 0, verxj = 0;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			if (used[i][j] == cnt) {
				verxi = i;
				verxj = j;
				break;
			}
		}
		if (verxi != 0 && verxj != 0) break;
	}
	int nisi = 0, nisj = 0;
	for (int i = n; i >= 1; i--) {
		for (int j = n; j >= 1; j--) {
			if (used[i][j] == cnt) {
				nisi = i;
				nisj = j;
				break;
			}
		}
		if (nisi != 0 && nisj != 0) break;
	}
	int levoi = 0, levoj = 0;
	for (int j = 1; j <= n; j++) {
		for (int i = n; i >= 1; i--) {
			if (used[i][j] == cnt) {
				levoi = i;
				levoj = j;
				break;
			}
		}
		if (levoi != 0 && levoj != 0) break;
	}
	int pravoi = 0, pravoj = 0;
	for (int j = n; j >= 1; j--) {
		for (int i = n; i >= 1; i--) {
			if (used[i][j] == cnt) {
				pravoi = i;
				pravoj = j;
				break;
			}
		}
		if (pravoi != 0 && pravoj != 0) break;
	}
	ans.resize(n + 5, vector<char>(m + 5, '.'));
	int i = verxi - 1, j = verxj;
	while (i != pravoi || j != pravoj + 1) {
		if (a[i][j + 1] == '#' && j != pravoj + 1) {
			j++;
			ans[i][j] = '#';
			continue;
		}
		i++;
		ans[i][j] = '#';
	}
	while (i != nisi + 1 || j != nisj) {
		if (a[i + 1][j] == '#' && i != nisi + 1) {
			i++;
			ans[i][j] = '#';
			continue;
		}
		j--;
		ans[i][j] = '#';
	}
	while (i != levoi || j != levoj - 1) {
		if (a[i][j - 1] == '#' && j != levoj - 1) {
			j--;
			ans[i][j] = '#';
			continue;
		}
		i--;
		ans[i][j] = '#';
	}
	while (i != verxi - 1 || j != verxj) {
		if (a[i - 1][j] == '#' && i != verxi - 1) {
			i--;
			ans[i][j] = '#';
			continue;
		}
		j++;
		ans[i][j] = '#';
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			cout << ans[i][j];
		}
		cout << '\n';
	}
	return 0;
}