#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define int long long
#define pb push_back

const int INF = 2e9;

struct SegTree {
    vector<int> t, add;
    SegTree(int n) {
        t.resize(4 * n, -INF);
        add.resize(4 * n);
    }
    void inc(int v, int val) {
        t[v] += val;
        add[v] += val;
    }
    void push(int v) {
        inc(v * 2, add[v]);
        inc(v * 2 + 1, add[v]);
        add[v] = 0;
    }
    void update(int v, int tl, int tr, int l, int r, int val) {
        if (l > r) return;
        if (tl == l && tr == r) {
            inc(v, val);
            return;
        }
        push(v);
        int tm = (tl + tr) / 2;
        update(2 * v, tl, tm, l, min(r, tm), val), update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }
    void update_pos(int v, int l, int r, int pos, int val) {
        if (l == r) {
            t[v] = val;
            return;
        }
        push(v);
        int m = (l + r) / 2;
        if (pos <= m) {
            update_pos(2 * v, l, m, pos, val);
        } else {
            update_pos(2 * v + 1, m + 1, r, pos, val);
        }
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }
    int get(int v, int tl, int tr, int l, int r) {
        if (l > r) return -INF;
        if (tl == l && tr == r) {
            return t[v];
        }
        push(v);
        int tm = (tl + tr) / 2;
        return max(get(2 * v, tl, tm, l, min(r, tm)), get(2 * v + 1, tm + 1, tr, max(l, tm + 1), r));
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, b, c;
    cin >> n >> b >> c;
    vector<int> x(n), p(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i];
    }
    int cur = 0;
    x.pb(INF);
    SegTree t(n);
    set<pair<int,int>> st;
    for (int i = 0; i < n; i++) {
        t.update_pos(1, 0, n - 1, i, cur);
        st.insert({p[i], -i});
        while (cur < x[i + 1] - x[i]) {
            if (st.size() == 0) break;
            auto to = *st.begin();
            int j = abs(to.second);
            int mx = t.get(1, 0, n - 1, j, i);
            if (mx == c) {
                st.erase(to);
                continue;
            }
            int add = min(x[i + 1] - x[i] - cur, c - mx);
            int can = b / to.first;
            if (can == 0) {
                break;
            }
            add = min(can, add);
            b -= to.first * add;
            t.update(1, 0, n - 1, j, i, add);
            cur += add;
        }
        if (cur >= x[i + 1] - x[i]) {
            cur -= x[i + 1] - x[i];
        } else {
            cout << x[i] + cur << endl;
            return 0;
        }
    }
    return 0;
}