#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define int long long

constexpr ll inf = 1e18;

constexpr int mod = 1e9 + 7;

int add(int x, int y) {
    return x + y >= mod ? x + y - mod : x + y;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    int s, t;
    ll l;
    cin >> s >> t >> l;
    s--, t--;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }

    auto dijkstra = [&](int source) -> vector<ll> {
        vector<ll> dist(n, inf);
        dist[source] = 0;

        set<pair<ll, int>> st;
        st.emplace(0, source);

        while (!st.empty()) {
            auto [d, v] = *st.begin();
            st.erase(st.begin());
            for (auto [to, w] : g[v]) {
                if (dist[to] > d + w) {
                    st.erase({dist[to], to});
                    dist[to] = d + w;
                    st.insert({dist[to], to});
                }
            }
        }

        return dist;
    };

    auto dist_t = dijkstra(t);
    auto dist_s = dijkstra(s);

    vector<vector<pair<int, int>>> g_s(n), g_t(n);
    for (int i = 0; i < n; ++i) {
        for (auto [to, w] : g[i]) {
            if (dist_s[t] == dist_s[i] + w + dist_t[to]) {
                g_s[i].emplace_back(to, w);
            }
            if (dist_t[i] + w == dist_t[to]) {
                g_t[i].emplace_back(to, w);
            }
        }
    }

    vector<int> ords(n);
    iota(ords.begin(), ords.end(), 0);
    auto ordt = ords;

    sort(ords.begin(), ords.end(), [&](int i, int j) {
        return dist_s[i] < dist_s[j];
    });

    sort(ordt.begin(), ordt.end(), [&](int i, int j) {
        return dist_t[i] < dist_t[j];
    });

    vector<int> cnts(n), cntt(n);

    cnts[s] = cntt[t] = 1;

    for (int v : ordt) {
        for (auto [to, w] : g_t[v]) {
            cntt[to] = add(cntt[to], cntt[v]);
        }
    }

    for (int v : ords) {
        for (auto [to, w] : g_s[v]) {
            cnts[to] = add(cnts[to], cnts[v]);
        }
    }

    if (l == dist_s[t]) {
        cout << cnts[t] << endl;
        return 0;
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (auto [to, w] : g[i]) {
            if (dist_s[i] + w + dist_t[to] == l) {
                ans = add(ans, 1LL * cnts[i] * cntt[to] % mod);
            }
        }
    }

    cout << ans << '\n';


    return 0;
}
