#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int mod = 1e9 + 7;

const int R = 1 << 19;

int sum[R * 2];

void change(int pos, int val) {
    for (pos += R; pos > 0; pos /= 2) {
        sum[pos] += val;
        if (sum[pos] >= mod) {
            sum[pos] -= mod;
        }
    }
}

int get(int l, int r) {
    l += R;
    r += R;
    int ans = 0;
    while (l < r) {
        if (l & 1) {
            ans += sum[l++];
            if (ans >= mod) {
                ans -= mod;
            }
        }
        if (r & 1) {
            ans += sum[--r];
            if (ans >= mod) {
                ans -= mod;
            }
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> l(n), r(n);
    vector<pair<pair<int, int>, int>> a;
    vector<int> b;
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        l[i]--;
        b.push_back(l[i]);
        b.push_back(r[i]);
    }
    sort(b.begin(), b.end());
    b.resize(unique(b.begin(), b.end()) - b.begin());
    for (int i = 0; i < n; ++i) {
        l[i] = lower_bound(b.begin(), b.end(), l[i]) - b.begin();
        r[i] = lower_bound(b.begin(), b.end(), r[i]) - b.begin();
        a.emplace_back(make_pair(r[i], r[i] - l[i]), i);
    }
    sort(a.begin(), a.end());
    set<pair<int, int>> s;
    vector<int> ans(n);
    for (auto [p, ind] : a) {
        ans[ind] = get(l[ind], r[ind]) + 1;
        if (ans[ind] >= mod) {
            ans[ind] -= mod;
        }
        while (true) {
            auto it = s.lower_bound({l[ind], 0});
            if (it != s.end() && it->first <= r[ind]) {
                change(l[ind], -ans[it->second]);
                s.erase(it);
            } else {
                break;
            }
        }
        change(l[ind], ans[ind]);
        s.insert({l[ind], ind});
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
    return 0;
}
