#include "bits/stdc++.h"

using namespace std;
#define int long long
struct edge {
    int v, w;
};
vector<vector<edge>> g;

int n;
const int inf = 1e18;
const int mod = 1e9 + 7;

vector<pair<int, int>> f(int s) {
    set<pair<int, int>> st;
    vector<pair<int, int>> d(n);
    for (int i = 0; i < n; ++i)
        d[i] = {inf, i};
    d[s].first = 0;
    st.insert({0, s});
    while (!st.empty()) {
        auto [val, i] = *st.begin();
        st.erase(st.begin());
        if (d[i].first != val)
            continue;
        for (auto [v, w]: g[i]) {
            if (d[v].first > w + d[i].first) {
                d[v].first = w + d[i].first;
                st.insert({d[v].first, v});
            }
        }
    }
    return d;
}

void solve() {
    int m, s, t, L;
    cin >> n >> m >> s >> t >> L;
    --s, --t;
    g.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    vector<pair<int, int>> ds = f(s);
    vector<int> MNS(n);
    for (int i = 0; i < n; ++i)
        MNS[i] = ds[i].first;
    sort(ds.begin(), ds.end());
    vector<pair<int, int>> dt = f(t);
    vector<int> MNT(n);
    for (int i = 0; i < n; ++i) {
        MNT[i] = dt[i].first;
    }
    sort(dt.begin(), dt.end());
    vector<int> cs(n), ct(n);
    cs[s] = 1;
    ct[t] = 1;
    for (auto [d, u]: ds) {
        if (d + MNT[u] == MNS[t])
            for (auto [v, w]: g[u])
                if (MNS[v] + w == MNS[u])
                    (cs[u] += cs[v]) %= mod;
    }
    for (auto [d, u]: dt)
        for (auto [v, w]: g[u])
            if (MNT[v] + w == MNT[u])
                (ct[u] += ct[v]) %= mod;
    int ans = 0;
    for (int i = 0; i < n; ++i)
        for (auto [j, len]: g[i])
            if (MNS[i] + MNT[j] + len == L)
                (ans += cs[i] * ct[j] % mod) %= mod;
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
