#include <bits/stdc++.h>
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
const int N = (int) 1e5 + 100;
const ll INF = LLONG_MAX;
struct setree {
    vector<pair<ll, ll>> tree;
    ll size;

    void init(ll n) {
        size = 1;
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, {-INF, INF});
    }

    void build(vector<ll> &a, ll x, ll l, ll r) {
        if (r - l == 1) {
            if (l < (ll) a.size()) {
                tree[x].first = a[l];
                tree[x].second = a[l];
            }
            return;
        }
        ll m = (r + l) / 2;
        build(a, 2 * x + 1, l, m);
        build(a, 2 * x + 2, m, r);
        tree[x].first = max(tree[2 * x + 1].first, tree[2 * x + 2].first);
        tree[x].second = min(tree[2 * x + 1].second, tree[2 * x + 2].second);
    }

    void build(vector<ll> &a) {
        init((ll) a.size());
        build(a, 0, 0, size);
    }

    pair<ll, ll> get(ll l, ll r, ll x, ll lx, ll rx) {
        if (lx >= r || rx <= l) return {-INF, INF};
        if (l <= lx && rx <= r) return tree[x];
        ll m = (rx + lx) / 2;
        pair<ll, ll> s1 = get(l, r, 2 * x + 1, lx, m);
        pair<ll, ll> s2 = get(l, r, 2 * x + 2, m, rx);
        return {max(s1.first, s2.first), min(s1.second, s2.second)};
    }

    pair<ll, ll> get(ll l, ll r) {
        return get(l, r, 0, 0, size);
    }
};
int main(){
    ios_base::sync_with_stdio(NULL), cin.tie(0), cout.tie(0);
    ll n, mn, mx, ans = INF, nummx = -INF, nummn = INF;
    cin >> n;
    ll arr[n];
    for(ll i = 0; i < n; i++){
        cin >> arr[i];
    }
    sort(arr, arr + n);
    vector <ll> fir;
    setree st;
    for(ll i = 0; i < n / 2; i++) {
        fir.pb(arr[i] + arr[n - i - 2]);
    }
    st.build(fir);
    ll l = 0, r = n / 2;
    pair <ll, ll> k = st.get(0, r);
    ans = k.first - k.second;

    for(ll i = n - 1; i > n / 2; i--){
        l++;
        k = st.get(l, r);
        nummn = min(nummn, arr[i] + arr[n - i - 1]);
        nummx = max(nummx, arr[i] + arr[n - i - 1]);
        if(i == n/2 + 1) ans = min(ans, nummx - nummn);
        else{
            mn = min(k.second, nummn);
            mx = max(k.first, nummx);
            ans = min(ans, mx - mn);
        }
    }
    fir.clear();
    for(ll i = n - 1; i > n / 2; i--) {
        fir.pb(arr[i] + arr[n - i]);
    }
    st.build(fir);
    l = 0;
    k = st.get(0, r);
    ans = min(ans, k.first - k.second);
    for(ll i = 0; i < n / 2; i++){
        l++;
        k = st.get(l, r);
        nummn = min(nummn, arr[i] + arr[n - i - 1]);
        nummx = max(nummx, arr[i] + arr[n - i - 1]);
        if(i == n/2 - 1) ans = min(ans, nummx - nummn);
        else{
            mn = min(k.second, nummn);
            mx = max(k.first, nummx);
            ans = min(ans, mx - mn);
        }
    }
    cout << ans;
}

