#include <set>
#include <map>
#include <vector>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <algorithm>
using namespace std;
const int M = 2e5 + 10, PP = 1e9 + 7;
long long x[M], y[M], z[M];
const long long INF = 1e18;
vector <vector<pair<int, long long>>> G;
void dijkstra(int v, vector <pair<long long, int>> &D) {
    for (int i = 0; i < (int)D.size(); i++) {
        D[i] = { INF, 0 };
    }
    set <pair<long long, int>> ms;
    D[v] = { 0, 1 };
    ms.insert({ 0, v });
    while (!ms.empty()) {
        long long vertex = ms.begin()->second; ms.erase(ms.begin());
        for (auto it : G[vertex]) {
            if (D[vertex].first + it.second < D[it.first].first) {
                auto j = ms.find({ D[it.first].first, it.first });
                if (j != ms.end()) ms.erase(j);
                D[it.first].second = 1;
                D[it.first].first = D[vertex].first + it.second;
                ms.insert({ D[it.first].first, it.first });
            }
            else if (D[vertex].first + it.second == D[it.first].first) {
                D[it.first].second += D[vertex].second;
                D[it.first].second %= PP;
            }
        }
    }
}
int main()
{
    int n, m, s, t;
    long long L;
    cin >> n >> m >> s >> t >> L;
    G.resize(n + 1);
    for (int i = 1; i <= m; i++) {
        cin >> x[i] >> y[i] >> z[i];
        G[x[i]].push_back({ y[i], z[i] });
        G[y[i]].push_back({ x[i], z[i] });
    }
    vector <pair<long long, int>> Ds, Dt;
    Ds.resize(n + 1);
    Dt.resize(n + 1);
    dijkstra(s, Ds);
    dijkstra(t, Dt);
    if (Ds[t].first == L) {
        cout << Ds[t].second << "\n";
        return 0;
    }
    long long ans = 0;
    for (int i = 1; i <= m; i++) {
        if (z[i] + Ds[x[i]].first + Dt[y[i]].first == L) {
            long long k;
            if (Ds[y[i]].first + z[i] == Ds[x[i]].first) k = ((Ds[y[i]].second - 1) * Dt[y[i]].second) % PP;
            else k = (Ds[x[i]].second * Dt[y[i]].second) % PP;
            ans += k;
            ans %= PP;
        }
        if (z[i] + Ds[y[i]].first + Dt[x[i]].first == L) {
            long long k = (Ds[y[i]].second * Dt[x[i]].second) % PP;
            if (Ds[x[i]].first + z[i] == Ds[y[i]].first) k = ((Ds[x[i]].second - 1) * Dt[x[i]].second) % PP;
            else k = (Ds[x[i]].second * Dt[y[i]].second) % PP;
            ans += k;
            ans %= PP;
        }

    }
    cout << ans << "\n";
}