﻿#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <cmath>
#include <iomanip>
#include <iostream>
using namespace std;
const int N = 25e4 + 10;
int tree1[4 * N], tree2[4 * N], a[2 * N], A[N];
void build_tree1(int v, int tl, int tr) {
    if (tl == tr) tree1[v] = A[tl];
    else {
        int tm = (tl + tr) / 2;
        build_tree1(2 * v, tl, tm);
        build_tree1(2 * v + 1, tm + 1, tr);
        tree1[v] = min(tree1[2 * v], tree1[2 * v + 1]);
    }
}
void build_tree2(int v, int tl, int tr) {
    if (tl == tr) tree2[v] = A[tl];
    else {
        int tm = (tl + tr) / 2;
        build_tree2(2 * v, tl, tm);
        build_tree2(2 * v + 1, tm + 1, tr);
        tree2[v] = max(tree2[2 * v], tree2[2 * v + 1]);
    }
}
void update1(int v, int tl, int tr, int pos, int diff) {
    if (tl > pos || tr < pos) return;
    if (tl == tr) tree1[v] += diff;
    else {
        int tm = (tl + tr) / 2;
        update1(2 * v, tl, tm, pos, diff);
        update1(2 * v + 1, tm + 1, tr, pos, diff);
        tree1[v] = min(tree1[2 * v], tree1[2 * v + 1]);
    }
}
void update2(int v, int tl, int tr, int pos, int diff) {
    if (tl > pos || tr < pos) return;
    if (tl == tr) tree2[v] += diff;
    else {
        int tm = (tl + tr) / 2;
        update2(2 * v, tl, tm, pos, diff);
        update2(2 * v + 1, tm + 1, tr, pos, diff);
        tree2[v] = max(tree2[2 * v], tree2[2 * v + 1]);
    }
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0);
    int n;
    scanf("%d", &n);
    for (int i = 1; i <= n; i++) {
        scanf("%d", &a[i]);
    }
    sort(a + 1, a + 1 + n);
    for (int i = 1; i <= (n / 2); i++) {
        A[i] = a[i] + a[n + 1 - i];
    }
    build_tree1(1, 1, n / 2);
    build_tree2(1, 1, n / 2);
    int ans = tree2[1] - tree1[1];
    for (int i = (n / 2); i >= 1; i--) {
        update1(1, 1, n / 2, i, a[i + 1] - a[i]);
        update2(1, 1, n / 2, i, a[i + 1] - a[i]);
        ans = min(ans, tree2[1] - tree1[1]);
    }
    build_tree1(1, 1, n / 2);
    build_tree2(1, 1, n / 2);
    for (int i = (n / 2) + 2; i <= n; i++) {
        update1(1, 1, n / 2, n - i + 1, a[i] - a[i - 1]);
        update2(1, 1, n / 2, n - i + 1, a[i] - a[i - 1]);
        ans = min(ans, tree2[1] - tree1[1]);
    }

    cout << ans << "\n";
}