#include <bits/stdc++.h>
using namespace std;

void fastIO() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
}

const long long inf = 1e16, mod = 1e9 + 7;
const int N = 1e5 + 10;

long long n, pox, cap, x[N], p[N];

struct segTree {

  struct node {
    long long value, lazy;
  };

  long long size = 1;
  vector<node> tree;

  void init(long long s) {
    while(size < s) {
      size *= 2;
    }
    tree.assign(2 * size - 1, {0, 0});
  }

  void propagate(int x, int lx, int rx) {
    if(tree[x].lazy == 0) {
      return;
    }

    if(rx - lx == 1) {
      return;
    }

    tree[2 * x + 1].value += tree[x].lazy;
    tree[2 * x + 2].value += tree[x].lazy;

    tree[2 * x + 1].lazy += tree[x].lazy;
    tree[2 * x + 2].lazy += tree[x].lazy;

    tree[x].lazy = 0;
  }

  void upd(int l, int r, long long value, int x, int lx, int rx) {
    propagate(x, lx, rx);
    if(lx >= r || rx <= l) {
      return;
    }

    if(lx >= l && rx <= r) {
      tree[x] = {tree[x].value + value, tree[x].lazy + value};
      return;
    }

    int mid = (lx + rx) / 2;
    upd(l, r, value, 2 * x + 1, lx, mid);
    upd(l, r, value, 2 * x + 2, mid, rx);
    tree[x].value = max(tree[2 * x + 1].value, tree[2 * x + 2].value);
  }

  void upd(int l, int r, long long value) {
    upd(l, r, value, 0, 0, size);
  }

  long long qry(int l, int r, int x, int lx, int rx) {
    propagate(x, lx, rx);

    if(lx >= r || rx <= l) {
      return LLONG_MIN;
    }

    if(lx >= l && rx <= r) {
      return tree[x].value;
    }

    int mid = (lx + rx) / 2;
    long long s1 = qry(l, r, 2 * x + 1, lx, mid);
    long long s2 = qry(l, r, 2 * x + 2, mid, rx);
    return max(s1, s2);
  }

  long long qry(int l, int r) {
    return qry(l, r, 0, 0, size);
  }
};

#define dbg(x) cerr << #x << ": " << x << endl;

void solve() {
  cin >> n >> pox >> cap;
  for(int i = 0; i < n; ++i) cin >> x[i] >> p[i];
  segTree st; st.init(n + 1);
  set<pair< long long,  long long> > s;
  s.insert({p[0], 0});
  long long cur = 0, coord = 0;
  for(int i = 1; i < n; ++i) {
    auto it = *s.begin();
    long long maxi = st.qry(it.second, i), xx = min(cap - maxi, x[i] - x[i - 1]);
    if(cur + xx * it.first > pox) {
      //inchqan karanq anenq u durs ganq
      long long karanq = (pox - cur) / it.first;
      cout << karanq + coord;
      return;
    }
    else {
      st.upd(it.second, i, xx);
      cur += xx * it.first;
      if(xx != x[i] - x[i - 1]) {
        coord += xx;
        x[i - 1] = coord;
        i--; //het kganq bayc urish coordov
        s.erase(s.begin());
        continue;
      } else {
        coord = x[i];
        s.insert({p[i], i});
      }
    }
  }

  //der pox ka
  pox -= cur;
  while(pox && s.size()) {
    // dbg(pox) dbg(coord)
    auto it = *s.begin();
    // dbg(it.first)
    long long maxi = st.qry(it.second, n), xx = cap - maxi;
    if(pox < xx * it.first) {
      //inchqan karanq anenq u durs ganq
      long long karanq = pox  / it.first;
      cout << karanq + coord;
      return;
    }
    else {
      st.upd(it.second, n, xx);
      coord += xx;
      pox -= xx * it.first;
      s.erase(s.begin());
    }
  }
  cout << coord;
}

int main() {
  int test_cases = 1;
  // cin >> test_cases;

  while(test_cases--) {
    solve();
  }
  return 0;
}