#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;

template<typename T>
bool rmax(T& a, T b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
bool rmin(T& a, T b) {
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T>& a) {
    for (auto &it : a) {
        in << it << ' ';
    }
    return in;
}

const int INF = 1e9 + 7;
int add(int a, int b) {
    int c = (a + b) % INF;
    if (c < 0) {
        c += INF;
    }
}

int mul(int a, int b) {
    int c = (a * b) % INF;
    if (c < 0) {
        c += INF;
    }
    return c;
}

const int MAXN = 2e5 + 1;
vector<pii> adj[MAXN];
bool used[MAXN];
vector<int> dag_from_start[MAXN];
vector<int> dag_from_end[MAXN];
int cnt_in_first_dag[MAXN];
int cnt_in_second_dag[MAXN];
int dist_from_start[MAXN];
int dist_from_end[MAXN];

void dijkstra(int st, int type) {
    fill(used, used + MAXN, 0);
    if (type == 1)
        dist_from_start[st] = 0;
    else
        dist_from_end[st] = 0;

    priority_queue<pii> q;
    q.push({0, st});

    while (!q.empty()) {
        int v = q.top().Y;
        q.pop();

        if (used[v]) {
            continue;
        }

        used[v] = 1;

        for (auto &it : adj[v]) {
            if (!used[it.X]) {
                if (type == 1) {
                    if (rmin(dist_from_start[it.X], dist_from_start[v] + it.Y)) {
                        q.push({-dist_from_start[it.X], it.X});
                    }
                } else {
                    if (rmin(dist_from_end[it.X], dist_from_end[v] + it.Y)) {
                        q.push({-dist_from_end[it.X], it.X});
                    }
                }
            }
        }
    }

    for (int i = 0; i < MAXN; i++) {
        for (auto it : adj[i]) {
            if (type == 1) {
                if (dist_from_start[i] + it.Y == dist_from_start[it.X]) {
                    dag_from_start[it.X].push_back(i);
//                    cout << it.X << ' ' << i << endl;
                }
            } else {
                if (dist_from_end[i] + it.Y == dist_from_end[it.X]) {
                    dag_from_end[it.X].push_back(i);
//                    cout << it.X << ' ' << i << endl;
                }
            }
        }
    }
}

bool dfs(int v, int en, int type) {
    if (v == en) {
        used[v] = 1;
        if (type == 1) {
            cnt_in_first_dag[v] = 1;
        } else {
            cnt_in_second_dag[v] = 1;
        }

        return 1;
    }

    used[v] = 1;
    bool has = 0;
    if (type == 1) {
        cnt_in_first_dag[v] = 0;
    } else {
        cnt_in_second_dag[v] = 0;
    }

    if (type == 1) {
        for (auto &it: dag_from_start[v]) {
            if (!used[it]) {
                if (dfs(it, en, type)) {
                    has = 1;
                    cnt_in_first_dag[v] = add(cnt_in_first_dag[v], cnt_in_first_dag[it]);
                }
            }
        }
    } else {
        for (auto &it: dag_from_end[v]) {
            if (!used[it]) {
                if (dfs(it, en, type)) {
                    has = 1;
                    cnt_in_second_dag[v] = add(cnt_in_second_dag[v], cnt_in_second_dag[it]);
                }
            }
        }
    }

    return has;
}

void calc_first(int s, int t) {
    dijkstra(s, 1);
    fill(used, used + MAXN, 0);
    dfs(t, s, 1);

    dijkstra(t, 0);
    fill(used, used + MAXN, 0);
    dfs(s, t, 0);
}


void solve() {
    int n;
    cin >> n;
    int m;
    cin >> m;

    for (int i = 0; i < MAXN; i++) {
        cnt_in_second_dag[i] = cnt_in_second_dag[i] = 0;
        dist_from_end[i] = dist_from_start[i] = 1e18;
    }
    int s, t, l;
    cin >> s >> t >> l;
    --s; --t;
    while (m--) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;

        adj[u].push_back({v, w});
        adj[v].push_back({u, w});
    }

    calc_first(s, t);
    int cnt = 0;

    for (int i = 0; i < n; i++) {
        for (auto &it : adj[i]) {
            int len = dist_from_start[i] + dist_from_end[it.X] + it.Y;
            if (len == l) {
                cnt = add(mul(cnt_in_first_dag[i], cnt_in_second_dag[i]), cnt);
            }
        }
    }

//    cout << cnt_in_second_dag[s] << endl;

    cout << cnt << endl;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("..\\input.txt", "r",  stdin);
    freopen("..\\output.txt", "w", stdout);
#endif

    int t  = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}