#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;

template<typename T>
bool rmax(T& a, T b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
bool rmin(T& a, T b) {
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T>& a) {
    for (auto &it : a) {
        in << it << ' ';
    }
    return in;
}

const int INF = 1e9 + 7;
int add(int a, int b) {
    int c = (a + b) % INF;
    if (c < 0) {
        c += INF;
    }
    return c;
}

int mul(int a, int b) {
    int c = (a * b) % INF;
    if (c < 0) {
        c += INF;
    }
    return c;
}

const int MAXN = 2e5 + 1;
vector<pii> adj[MAXN];
bool used[MAXN];
vector<int> dag_from_start[MAXN];
vector<int> dag_from_end[MAXN];
int cnt_in_first_dag[MAXN];
int cnt_in_second_dag[MAXN];
int dist_from_start[MAXN];
int dist_from_end[MAXN];

void dijkstra(int st, int type) {
    fill(used, used + MAXN, 0);
    if (type == 1)
        dist_from_start[st] = 0;
    else
        dist_from_end[st] = 0;

    priority_queue<pii> q;
    q.push({0, st});

    while (!q.empty()) {
        int v = q.top().Y;
        q.pop();

        if (used[v]) {
            continue;
        }

        used[v] = 1;

        for (auto &it : adj[v]) {
            if (!used[it.X]) {
                if (type == 1) {
                    if (rmin(dist_from_start[it.X], dist_from_start[v] + it.Y)) {
                        q.push({-dist_from_start[it.X], it.X});
                    }
                } else {
                    if (rmin(dist_from_end[it.X], dist_from_end[v] + it.Y)) {
                        q.push({-dist_from_end[it.X], it.X});
                    }
                }
            }
        }
    }

    for (int i = 0; i < MAXN; i++) {
        for (auto it : adj[i]) {
            if (type == 1) {
                if (dist_from_start[i] + it.Y == dist_from_start[it.X]) {
                    dag_from_start[it.X].push_back(i);
//                    cout << it.X << ' ' << i << endl;
                }
            } else {
                if (dist_from_end[i] + it.Y == dist_from_end[it.X]) {
                    dag_from_end[it.X].push_back(i);
//                    cout << it.X << ' ' << i << endl;
                }
            }
        }
    }
}

bool dfs(int v, int en, int type) {
    if (v == en) {
        used[v] = 1;
        if (type == 1) {
            cnt_in_first_dag[v] = 1;
        } else {
            cnt_in_second_dag[v] = 1;
        }

        return 1;
    }

    used[v] = 1;
    bool has = 0;
    if (type == 1) {
        cnt_in_first_dag[v] = 0;
    } else {
        cnt_in_second_dag[v] = 0;
    }

    if (type == 1) {
        for (auto &it: dag_from_start[v]) {
            if (!used[it]) {
                if (dfs(it, en, type)) {
                    has = 1;
                    cnt_in_first_dag[v] = add(cnt_in_first_dag[v], cnt_in_first_dag[it]);
                }
            }
        }
    } else {
        for (auto &it: dag_from_end[v]) {
            if (!used[it]) {
                if (dfs(it, en, type)) {
                    has = 1;
                    cnt_in_second_dag[v] = add(cnt_in_second_dag[v], cnt_in_second_dag[it]);
                }
            }
        }
    }

    return has;
}

void calc_first(int s, int t) {
    dijkstra(s, 1);
    fill(used, used + MAXN, 0);
    dfs(t, s, 1);

    dijkstra(t, 0);
    fill(used, used + MAXN, 0);
    dfs(s, t, 0);
}

int MOD = 1e9 + 7;

struct Integer {
    int i;
};

Integer operator + (Integer a, Integer b) {
    a.i = add(a.i, b.i);
    return a;
}

Integer operator - (Integer a, Integer b) {
    a.i = add(a.i, -b.i);
    return a;
}

Integer operator * (Integer a, Integer b) {
    a.i = mul(a.i, b.i);
    return a;
}

Integer operator * (Integer a, int b) {
    a.i = mul(a.i, b);
    return a;
}

void solve() {
    int MOD = 1e9 + 7;
    int H, W;
    cin >> H >> W;
    if (H == 1 || W == 1){
        cout << H*W;
        return;
    }
    vector<vector<int>> s(H + 1, vector<int>(W + 1, 0));
    vector<vector<int>> cnt(H + 1, vector<int>(W + 1, 0));
    for (int i = 1; i <= 2; i++){
        for (int j = 1; j <= H; j++){
            s[j][i] = j*i;
            cnt[j][i] = 1;
        }
        for (int j = 1; j <= W; j++){
            s[i][j] = j*i;
            cnt[i][j] = 1;
        }
    }
    for (int h = 3; h <= H; h++){
        int hsum = 0;
        int rsum = 0;
        int c = 0;
        int rc = 0;
        for (int w = 3; w <= W; w++){
            rsum += s[h - 2][w - 2];
            hsum += rsum;
            rc += cnt[h - 2][w - 2];
            c += rc;
            s[h][w] = 2*s[h - 1][w] + 2*w*cnt[h - 1][w] - s[h - 2][w] - 2*w*cnt[h - 2][w]
                      + hsum + h*w*c;
            cnt[h][w] = 2*cnt[h - 1][w] - cnt[h - 2][w] + c;
        }
    }

    cout << s[H][W];
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("..\\input.txt", "r", stdin);
    freopen("..\\output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}