#include <bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long double ld;
typedef long long ll;
#define int ll

struct Node {
    int len, sm, cnt; // cnt - количество нулей на отрезке покрывающий вершину
    Node *l, *r;

    Node(int lenn) {
        l = r = nullptr;
        len = lenn, sm = 0, cnt = lenn;
    }
};

const int R = 1ll << 32;

struct Tree {
    Node *root;

    Tree() {
        root = new Node(R);
    }

    void update(int ql, int qr, int add, Node *node, int nl = 0, int nr = R) {
        if (ql <= nl && nr <= qr) {
            node->sm = 1;
            node->len = 1;
            node->cnt = 0;
            return;
        }
        if (qr <= nl || nr <= ql) {
            return;
        }
        if (!node->l) {
            node->l = new Node((nr - nl) / 2), node->r = new Node((nr - nl) / 2);
        }
        int nm = (nr + nl) / 2;
        update(ql, qr, add, node->l, nl, nm);
        update(ql, qr, add, node->r, nm, nr);
        node->sm = node->l->sm + node->r->sm;
        node->len = node->l->len + node->r->len;
        node->cnt = node->len - node->sm;
    }

    void update(int ind) {
        update(ind, ind + 1, 1, root);
    }

    int get(int ql, int qr, int k, Node *node, int nl = 0, int nr = R) {
        if (nl + 1 == nr) {
            return nl + 1;
        }
        if (!node->l) {
            node->l = new Node((nr - nl) / 2), node->r = new Node((nr - nl) / 2);
        }
        int nm = (nr + nl) / 2;
        if (k - node->l->cnt > 0) {
            return get(ql, qr, k - node->l->cnt, node->r, nm, nr);
        }
        return get(ql, qr, k, node->l, nl, nm);
    }

    int get(int k) {
        return get(0, R, k, root);
    }
};

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    Tree tree;
    for (auto &el : a) {
        tree.update(el);
    }
    while (q--) {
        int k;
        cin >> k;
        cout << tree.get(k) - 1 << " ";
    }
}