#include <bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long double ld;
typedef long long ll;
#define int ll

const int N = 1010;
string a[N];
int n, m;

bool used[N][N];
const vector<int> dx = {0, 1, 0, -1};
const vector<int> dy = {1, 0, -1, 0};
const vector<pair<int,int>> tor = {{1, 1}, {1, -1}, {-1, -1}, {-1, 1}};

bool ok(int x, int y){
    return 0 <= x && x < n && 0 <= y && y < m;
}

void dfs(int i, int j){
    if(!ok(i,j) || used[i][j] || a[i][j] == '#') return;
//    cerr << i << ' ' << j << "\n";
    used[i][j] = true;
    for(int t=0;t<4;++t){
        int ni = i + dx[t];
        int nj = j + dy[t];
        dfs(ni, nj);
    }
}

bool mark[N][N];

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin >> n >> m;
    for(int i=0;i<n;++i){
        string s;
        cin >> s;
        a[i] = s;
    }
    for(int i=0;i<n;++i){
        dfs(i, 0);
        dfs(i, m- 1);
    }
    for(int i=0;i<m;++i){
        dfs(0, i);
        dfs(n - 1, i);
    }

    queue<pair<int, int>> q;
    for(int i=0;i<n;++i){
        for(int j=0;j<m;++j){
            if(a[i][j] == '.' && !used[i][j]){
                for(int t=0;t<4;++t){
                    int ni = i + dx[t];
                    int nj = j + dy[t];
                    if(ok(ni, nj) && a[ni][nj] == '#'){
                        q.push({ni,nj});
                        mark[ni][nj] = true;
                    }
                }
                for(int t=0;t<4;++t){
                    int ni = i + tor[t].first;
                    int nj = j + tor[t].second;
                    if(ok(ni, nj) && a[ni][nj] == '#'){
                        q.push({ni,nj});
                        mark[ni][nj] = true;
                    }
                }
            }
        }
    }

    while(!q.empty()){
        int i = q.front().first;
        int j = q.front().second;
        q.pop();
        int c = 0;
        pair<int, int> kek;
        for(int t=0;t<4;++t){
            int ni = i + dx[t];
            int nj = j + dy[t];
            if(ok(ni, nj) && a[ni][nj] == '#' && mark[ni][nj]){
                c++;
                kek = {ni,nj};
            }
        }
        if(c == 1){
            mark[i][j] = false;
            mark[kek.first][kek.second] = true;
            q.push(kek);
        } else{
//            for(int t=0;t<4;++t){
//                int ni = i + dx[t];
//                int nj = j + dy[t];
//                if(ok(ni, nj) && a[ni][nj] == '#' && mark[ni][nj]){
//                    ni = i + dx[(t + 1) % 4];
//                    nj = j + dy[(t + 1) % 4];
//                    if(ok(ni, nj) && a[ni][nj] == '#' && mark[ni][nj]){
//                        mark[i][j] = false;
//                        mark[i + tor[t].first][j + tor[t].second] = true;
//                        q.push({ni, nj});
//                        q.push({i+dx[t], j + dy[t]});
//                        q.push({i + tor[t].first, j + tor[t].second});
//                    }
//                }
//            }
        }
    }
    vector<string> ans(n);
    for(int i=0;i<n;++i){
        for(int j=0;j<m;++j){
            if(mark[i][j]){
                ans[i] += '#';
            } else{
                ans[i] += '.';
            }
        }
        cout << ans[i] << "\n";
    }
}