#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<deque>
#include<set>

using namespace std;

#define int long long

struct edge{
	int u, v;
	long long w;
};
const long long INF = 2e15;
const long long MOD = 1e9 + 7;

edge edges[200005];
vector<pair<int, long long>> gr[200005];
pair<long long, long long> dist_s[200005];
pair<long long, long long> dist_t[200005];

int s, t;
long long l;
void Dijkstra1(int n) {
	for (int i = 0; i < n; i++) {
		dist_s[i] = { INF , 0 };
	}
	dist_s[s] = { 0, 1 };
	set<pair<long long, int>> sd;
	sd.insert({ 0, s });
	while (!sd.empty()) {
		auto [w, v] = *sd.begin();
		sd.erase(sd.begin());
		for (auto u : gr[v]) {
			if (w + u.second < dist_s[u.first].first) {
				sd.erase({ dist_s[u.first].first , u.first });
				dist_s[u.first] = { w + u.second, dist_s[v].second };
				sd.insert({ dist_s[u.first].first , u.first });
			}
			else if (w + u.second == dist_s[u.first].first) {
				dist_s[u.first].second += dist_s[v].second;
				dist_s[u.first].second %= MOD;
			}
		}
	}
}

void Dijkstra2(int n) {
	for (int i = 0; i < n; i++) {
		dist_t[i] = { INF , 0 };
	}
	dist_t[t] = { 0, 1 };
	set<pair<long long, int>> sd;
	sd.insert({ 0, t });
	while (!sd.empty()) {
		auto [w, v] = *sd.begin();
		sd.erase(sd.begin());
		for (auto u : gr[v]) {
			if (w + u.second < dist_t[u.first].first) {
				sd.erase({ dist_t[u.first].first , u.first });
				dist_t[u.first] = { w + u.second, dist_t[v].second };
				sd.insert({ dist_t[u.first].first , u.first });
			}
			else if (w + u.second == dist_t[u.first].first) {
				dist_t[u.first].second += dist_t[v].second;
				dist_t[u.first].second %= MOD;
			}
		}
	}
}

long long check(int u, int v, int w) {
	long long tf = min(dist_s[u].first + dist_t[v].first, dist_s[v].first + dist_t[u].first);
	if (tf + w == l) {
		return (dist_s[u].second * dist_t[v].second) % MOD;
	}
	return 0;
}

/*6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4*/
void solve() {
	int n, m;
	cin >> n >> m;
	cin >> s >> t >> l;
	s--; t--;
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--; v--;
		gr[u].push_back({ v, w });
		gr[v].push_back({ u, w });
		edges[i] = { u, v, w };
	}
	Dijkstra1(n); Dijkstra2(n);
	
	long long ans = 0;
	for (auto f : edges) {
		ans += check(f.u, f.v, f.w);
		//ans += check(f.v, f.u, f.w);
		ans %= MOD;
	}
	cout << ans << "\n";
	return;
}

signed main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;

	while (tt--) {
		solve();
	}
}