#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <string>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;
typedef long long ll;
typedef long double ld;
const long long INF = 1e18;
const int32_t MAXN = 2E5;
const int64_t MOD = 1E9 + 7;

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	int ans;
	Mod_int(const int64_t& ans = 0) :ans(ans% MOD) {}
	Mod_int operator+(const Mod_int& x) const
	{
		return ans + x.ans;
	}
	Mod_int operator+=(const Mod_int& x)
	{
		return *this = *this + x;
	}
	Mod_int operator* (const Mod_int& x) const
	{
		return int64_t(ans) * x.ans;
	}
	Mod_int operator*=(const Mod_int& x)
	{
		return *this = *this * x;
	}
};

char mas[1004][1004];
bool used[1004][1004];
const pair<int, int> mv[4] = { {1,0},{-1,0},{0,1},{0,-1} };
pair <int, int> pred[1004][1004];
bool ans[1004][1004];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			cin >> mas[i + 2][j + 2];
		}
	}

	for (int i = 0; i < m + 2; i++)
	{
		mas[1][i + 1] = '.';
		mas[0][i + 1] = '#';
		mas[n + 2][i + 1] = '.';
		mas[n + 3][i + 1] = '#';
	}
	for (int i = 0; i < n + 2; i++)
	{
		mas[i + 1][0] = '#';
		mas[i + 1][1] = '.';
		mas[i + 1][m + 2] = '.';
		mas[i + 1][m + 3] = '#';
	}

	queue <pair<int, int>> q;
	q.push({ 1,1 });
	used[1][1] = true;
	while (!q.empty())
	{
		auto t = q.front();
		q.pop();
		for (int i = 0; i < 4; i++)
		{
			int f = t.first + mv[i].first, s = t.second + mv[i].second;
			if (mas[f][s] == '.' and !used[f][s])
			{
				q.push({ f,s });
				used[f][s] = true;
			}
		}
	}

	pair <int, int> mn = { 2E3,0 }, mx = { -1,0 };
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (mas[i+2][j+2]=='.' and !used[i+2][j+2])
			{
				rmin(mn, { i + 2,j + 2 });
				rmax(mx, { i + 2,j + 2 });
			}
		}
	}

	for (int i = 0; i < 1004; i++)
	{
		for (int j = 0; j < 1004; j++)
		{
			used[i][j] = false;
		}
	}
	q.push({ mn.first - 1,mn.second - 1});
	used[mn.first - 1][mn.second - 1] = true;
	while (!q.empty())
	{
		auto t = q.front();
		q.pop();
		for (int i = 0; i < 4; i++)
		{
			int f = t.first + mv[i].first, s = t.second + mv[i].second;
			if (mas[f][s] == '#' and !used[f][s])
			{
				q.push({ f,s });
				used[f][s] = true;
				pred[f][s] = t;
			}
		}
	}

	mn.first--;
	mn.second--;
	pair <int, int> t = { mx.first + 1,mx.second - 1 };
	while (t != mn)
	{
		ans[t.first][t.second] = true;
		t = pred[t.first][t.second];
	}
	ans[t.first][t.second] = true;

	for (int i = 0; i < 1004; i++)
	{
		for (int j = 0; j < 1004; j++)
		{
			used[i][j] = false;
		}
	}
	q.push({ mx.first + 1,mx.second + 1 });
	used[mx.first + 1][mx.second + 1] = true;
	while (!q.empty())
	{
		auto t = q.front();
		q.pop();
		for (int i = 0; i < 4; i++)
		{
			int f = t.first + mv[i].first, s = t.second + mv[i].second;
			if (mas[f][s] == '#' and !used[f][s])
			{
				q.push({ f,s });
				used[f][s] = true;
				pred[f][s] = t;
			}
		}
	}

	mx.first++;
	mx.second++;
	t = { mn.first,mn.second + 2 };
	while (t != mx)
	{
		ans[t.first][t.second] = true;
		t = pred[t.first][t.second];
	}
	ans[t.first][t.second] = true;

	ans[mx.first][mx.second - 1] = true;
	ans[mn.first][mn.second + 1] = true;

	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (ans[i + 2][j + 2])
			{
				cout << '#';
			}
			else
				cout << '.';
		}
		cout << endl;
	}
}