#include <bits/stdc++.h>

using namespace std;

#define int long long

const int kek = 1e9 + 1;
const int mod = 1e9 + 7;
/*
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int h, w;
    cin >> h >> w;
    vector<int> roflpref(h + 1);
    vector<vector<int>> dp(h + 1, vector<int>(w + 1)), dppref(h + 1, vector<int>(w + 1)), pref(h + 1, vector<int>(w + 1)), rofl(h + 1, vector<int>(w + 1));
    for (int i = 1; i <= h; ++i) {
        for (int j = 1; j <= w; ++j) {
            if (j == 1) {
                if (i != 1) roflpref[i] = roflpref[i - 1] + i - 2;
                rofl[i][j] = 0;
                dp[i][j] = i * j;
                pref[i][j] = i * j;
                dppref[i][j] = 0;
                cout << i << ' ' << j << endl;
                cout << dp[i][j] << ' ' << pref[i][j] << ' ' << dppref[i][j] << endl;
                continue;
            }
            if (i == 1) {
                rofl[i][j] = rofl[i][j - 1] + 2 * roflpref[i];
                dp[i][j] = i * j;
                pref[i][j] = pref[i][j - 1] + i * j;
                dppref[i][j] = dppref[i][j - 1] + (j - 3 >= 0 ? pref[i][j - 3] : 0) + (j - 2 >= 0 ? dp[i][j - 2] : 0);
                cout << i << ' ' << j << endl;
                cout << dp[i][j] << ' ' << pref[i][j] << ' ' << dppref[i][j] << endl;
                continue;
            }
            rofl[i][j] = rofl[i][j - 1] + 2 * roflpref[i];
            rofl[i][j] %= mod;
            dp[i][j] += i * j * ((rofl[i][j] + 1) % mod);
            dp[i][j] %= mod;
            //for (int k = 1; k <= i - 2; ++k) {
            //    dp[i][j] += (i - 1 - k) * dppref[k][j];
           //    dp[i][j] %= mod;
            //}
            for (int k = 1; k <= i - 2; ++k) {
                for (int p = 1; p <= j - 2; ++p) {
                    dp[i][j] += (i - 1 - k) * (j - 1 - p) * dp[k][p];
                    dp[i][j] %= mod;
                }
            }
            pref[i][j] = pref[i][j - 1] + dp[i][j];
            pref[i][j] %= mod;
            dppref[i][j] = dppref[i][j - 1] + (j - 3 >= 0 ? pref[i][j - 3] : 0) + (j - 2 >= 0 ? dp[i][j - 2] : 0);
            dppref[i][j] %= mod;
            cout << i << ' ' << j << endl;
            cout << dp[i][j] << ' ' << pref[i][j] << ' ' << dppref[i][j] << endl;
        }
    }
    for (int i = 0; i <= h; ++i) cout << roflpref[i] << ' ';
    cout << endl;
    cout << dp[h][w] << endl;
} */

pair <int, int> delta[4] = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};

const int maxn = 1e3 + 7;
char path[maxn][maxn];

int bfs(int stx, int sty, int fx, int fy, vector <vector <char>> &a) {
    int n = (int)a.size();
    int m = (int)a[0].size();
    vector <vector <pair <int, int>>> par(n, vector <pair <int, int>> (m, {-1, -1}));
    vector <vector <int>> dist(n, vector <int> (m, 1e9));
    dist[stx][sty] = 0;
    queue <pair <int, int>> q;
    q.push({stx, sty});
    while (q.size()) {
        int vx = q.front().first;
        int vy = q.front().second;
        if (vx == fx && vy == fy)
            break;
        q.pop();
        for (int d = 0; d < 4; d++) {
            int nx = vx + delta[d].first;
            int ny = vy + delta[d].second;
            if (nx >= 0 && ny >= 0 && nx < n && ny < m && a[nx][ny] == '#') {
                if (dist[nx][ny] > dist[vx][vy] + 1) {
                    dist[nx][ny] = dist[vx][vy] + 1;
                    par[nx][ny] = {vx, vy};
                    q.push({nx, ny});
                }
            }
        }
    }
    int res = dist[fx][fy];
    while (fx != -1 && fy != -1) {
        path[fx][fy] = '#';
        auto t = par[fx][fy];
        fx = t.first, fy = t.second;
    }
    return res;
}

void paint(int x, int y, vector <vector <char>> &a, vector <vector <int>> &color) {
    int n = (int)a.size();
    int m = (int)a[0].size();
    queue <pair <int, int>> q;
    q.push({x, y});
    while (q.size()) {
        int vx = q.front().first;
        int vy = q.front().second;
        q.pop();
        for (int d = 0; d < 4; d++) {
            int nx = vx + delta[d].first;
            int ny = vy + delta[d].second;
            if (nx >= 0 && ny >= 0 && nx < n && ny < m && a[nx][ny] == '.') {
                if (color[nx][ny] == -1) {
                    color[nx][ny] = color[vx][vy];
                    q.push({nx, ny});
                }
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            path[i][j] = '.';
    vector <vector <char>> a(n, vector <char> (m, '.'));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector <vector <int>> color(n, vector <int> (m, -1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '#')
                color[i][j] = 1;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (color[i][j] == -1 && (i == 0 || j == 0 || j == m - 1 || i == n - 1)) {
                color[i][j] = 0;
                paint(i, j, a, color);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            if (color[i][j] == -1)
                color[i][j] = 2;
    }
    int max_x = -1, min_x = 1e9, max_y = -1, min_y = 1e9;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (color[i][j] != 2)
                continue;
            max_x = max(max_x, i);
            min_x = min(min_x, i);
            max_y = max(max_y, j);
            min_y = min(min_y, j);
        }
    }

    int minl = 1e9, maxl = -1e9;
    int minu = 1e9, maxu = -1e9;
    int minr = 1e9, maxr = -1e9;
    int mind = 1e9, maxd = -1e9;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (color[i][j] == 2) {
                if (i == min_x)
                    minu = min(minu, j), maxu = max(maxu, j);
                if (i == max_x)
                    mind = min(mind, j), maxd = max(maxd, j);
                if (j == min_y)
                    minl = min(minl, i), maxl = max(maxl, i);
                if (j == max_y)
                    minr = min(maxr, i), maxr = max(maxr, i);
            }
        }
    }
    bfs(min_x - 1, minu, min_x - 1, maxu, a);
    bfs(min_x - 1, maxu, minr, max_y + 1, a);
    bfs(minr, max_y + 1, maxr, max_y + 1, a);
    bfs(maxr, max_y + 1, max_x + 1, maxd, a);
    bfs(max_x + 1, maxd, max_x + 1, mind, a);
    bfs(max_x + 1, mind, maxl, min_y - 1, a);
    bfs(maxl, min_y - 1, minl, min_y - 1, a);
    bfs(minl, min_y - 1, min_x - 1, minu, a);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cout << path[i][j];
        cout << "\n";
    }
}