#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <set>
#include <vector>
#include <queue>
#include <array>

#define int int64_t
constexpr int mod = 1e9 + 7;

int mul(int a, int b) {
	return a * 1ULL * b % mod;
}
int add(int a, int b) {
	return a + b - mod * (a + b >= mod);
}

int n, m;

std::vector<std::array<int, 3>> edg;
std::vector<std::vector<std::pair<int, int>>> gr;

std::vector<std::pair<int64_t, int>> DJ(int s) {
	std::vector<bool> used(n);
	std::vector<int64_t> dist(n, 1e18);
	std::priority_queue<std::pair<int64_t, int>> heap;
	heap.push({ 0, s });

	while (!heap.empty()) {
		auto [d, v] = heap.top();
		heap.pop();
		d = -d;
		if (used[v]) {
			continue;
		}
		used[v] = true;
		dist[v] = d;
		for (auto [t, w] : gr[v]) {
			if (dist[t] > dist[v] + w) {
				dist[t] = dist[v] + w;
				heap.push({ -dist[t], t });
			}
		}
	}

	std::vector<int> vec(n);
	std::iota(vec.begin(), vec.end(), 0);
	std::sort(vec.begin(), vec.end(), [&](int a, int b) {return dist[a] < dist[b];  });
	std::vector<int> cnt(n);
	cnt[s] = 1;
	for (int i : vec) {
		for (auto [t, w] : gr[i]) {
			if (dist[t] == dist[i] + w) {
				cnt[t] = add(cnt[t], cnt[i]);
			}
		}
	}

	std::vector<std::pair<int64_t, int>> res(n);
	for (int i = 0; i < n; i++) {
		res[i] = { dist[i], cnt[i] };
	}
	return res;
}

int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int s, t;
	int64_t L;

	std::cin >> n >> m;
	std::cin >> s >> t >> L;
	s--; t--;
	edg.resize(m);
	gr.assign(n, {});
	for (auto& ar : edg) {
		auto& [u, v, w] = ar;
		std::cin >> u >> v >> w; u--; v--;
		gr[u].push_back({ v, w });
		gr[v].push_back({ u, w });
	}

	auto fuck_1 = DJ(s);
	auto fuck_2 = DJ(t);
	if (L < fuck_1[t].first) {
		std::cout << "0\n";
	} else if (L == fuck_1[t].first) {
		std::cout << fuck_1[t].second << "\n";
	} else {
		auto fuck = [&](int v) {
			return fuck_1[v].first + fuck_2[v].first == fuck_1[t].first;
		};
		int ans = 0;
		for (int i = 0; i < 2; i++)
			for (auto &[u, v, w] : edg) {
				if (fuck_1[u].first + w + fuck_2[v].first == L && fuck(u) ) {
					ans = add(ans, mul(fuck_1[u].second, fuck_2[v].second));
				}
				std::swap(u, v);
			}
		std::cout << ans << "\n";
	}


	return 0;
}


/*

6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4


*/