//#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt")
#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <cassert>
#include <set>
#include <vector>
#include <queue>
#include <array>
#include <chrono>
#include <immintrin.h>

#define int int64_t
constexpr int64_t inf = 1.1e18;

struct ST {
	std::vector<int> data;
	int size;

	ST(std::vector<std::pair<int, int>> input) {
		size = 1 << 32 - _lzcnt_u32(input.size());
		data.assign(size, 0);
		for (int i = 0; i < input.size(); i++) {
			data[size + i] = input[i].second;
		}
		for (int i = size; i > 0; i--) {
			data[i] = std::min(data[2 * i], data[2 * i + 1]);
		}
	}

	int get(int l, int r) {
		int res = 1.1e9;
		for (l += size, r += size; l < r; l >>= 1, r >>= 1) {
			if (l & 1) {
				res = std::min(res, data[l++]);
			}
			if (r & 1) {
				res = std::min(res, data[--r]);
			}
		}
		return res;
	}


};

signed main() {
	std::cin.tie(0)->sync_with_stdio(0);

	int n, B, C;
	std::cin >> n >> B >> C;
	std::vector<std::pair<int, int>> input(n);
	for (auto& [u, v] : input) {
		std::cin >> u >> v;
	}
	input.push_back({ (int)2.1e9, 1 });

	//ST st(input);
	int F = 0;
	int i = 0;
	int ans = 0;
	while (true) {
		if (ans != input[i].first) {
			exit(0);
		}
		assert(ans == input[i].first);

		int  j = i + 1;
		while (input[j].first - input[i].first <= C) {
			if (input[j].second <= input[i].second) {
				break;
			}
			j++;
		}
		if (input[j].first - input[i].first > C) {
			j--;
			if (i == j) {
				F += B / input[i].second;
				F = std::min(F, C);
				ans = input[i].first + F;
				break;
			}
			int b = std::min(C - F, B / input[i].second);
			B -= b * input[i].second;
			F += b;
			if (F < input[j].first - input[i].first) {
				ans += F;
				break;
			} else {
				F -= input[j].first - input[i].first;
				ans = input[j].first;
				i = j;
			}

		} else {
			int b = std::max<int>(0, (input[j].first - input[i].first) - F);
			if (input[i].second * b > B) {
				ans += F + B / input[i].second;
				break;
			} else {
				ans = input[j].second;
				B -= input[i].second * b;
				F += b;
				F -= (input[j].first - input[i].first);
				i = j;
			}
		}
	}

	std::cout << ans << "\n";

	std::cerr << clock() * 1.0 / CLOCKS_PER_SEC << std::endl;

	return 0;
}

/*
3 10 5
0 3
1 1
4 2


*/