#include <bits/stdc++.h>
#pragma GCC optimize("O3,no-stack-protector")

using namespace std;

const int64_t inf = 1e18 + 1329;

const int mod = 1'000'000'007;
int sum(int a, int b) {
    int c = a + b;
    if (c >= mod) c -= mod;
    return c;
}
int mul(int a, int b) {
    int64_t c = 1ll * a * b;
    if (c >= mod) c %= mod;
    return c;
}

const int maxn = 2e5 + 1329;

vector<pair<int, int>> g [maxn];

int64_t d[2][maxn];
int cnt[2][maxn];

void dijkstra(int s, int i, int n = maxn) {
    fill(d[i], d[i] + n, inf);
    fill(cnt[i], cnt[i] + n, 0);
    d[i][s] = 0;
    cnt[i][s] = 1;
    set<pair<int64_t, int>> vs;
    for (int v = 0; v < n; ++v) {
        vs.emplace(d[i][v], v);
    }
    while (!vs.empty()) {
        int u = (*vs.begin()).second;
        vs.erase(vs.begin());
        for (auto [v, w] : g[u]) {
            if (d[i][u] + w > d[i][v]) continue;
            if (d[i][u] + w == d[i][v]) {
                cnt[i][v] = sum(cnt[i][v], cnt[i][u]);
            } else {
                vs.erase(make_pair(d[i][v], v));
                d[i][v] = d[i][u] + w;
                vs.insert(make_pair(d[i][v], v));
                cnt[i][v] = cnt[i][u];
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m; cin >> n >> m;
    int s, t;
    int64_t L;
    cin >> s >> t >> L;
    s -= 1; t -= 1;
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u -= 1; v -= 1;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    dijkstra(s, 0, n);
    if (d[0][t] == L) {
        cout << cnt[0][t] << '\n';
        return 0;
    }
    dijkstra(t, 1, n);
    int ans = 0;
    for (int u = 0; u < n; ++u) {
        if (u == t) continue;
        if (d[0][u] + d[1][u] != d[0][t]) continue;
        for (auto [v, w] : g[u]) {
            if (d[0][u] + w + d[1][v] == L) {
                //cerr << u + 1 << ' ' << v + 1 << '\n';
                ans = sum(ans, mul(cnt[0][u], cnt[1][v]));
            }
        }
    }
    cout << ans << '\n';
}

/*

6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4

*/