#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF = 1e9;

int h, w;
vector<string> a;

pair<int, int> diff[] = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};

bool ok(int i, int j) {
    return 0 <= i && i < h && 0 <= j && j < w;
}

void fill(int i, int j) {
    a[i][j] = '*';
    for (auto [di, dj] : diff) {
        if (ok(i + di, j + dj) && a[i + di][j + dj] == '.') {
            fill(i + di, j + dj);
        }
    }
}

void solve() {
    cin >> h >> w;
    a.resize(h);
    for (int i = 0; i < h; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < h; ++i) {
        if (a[i][0] == '.') {
            fill(i, 0);
        }
        if (a[i][w - 1] == '.') {
            fill(i, w - 1);
        }
    }
    for (int j = 0; j < w; ++j) {
        if (a[0][j] == '.') {
            fill(0, j);
        }
        if (a[h - 1][j] == '.') {
            fill(h - 1, j);
        }
    }

    int ni = -1, nj = -1;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (a[i][j] == '.') {
                ni = i - 1, nj = j;
                break;
            }
        }
        if (ni != -1) break;
    }

    vector<vector<int>> dist1(h, vector<int> (w, INF));
    vector<vector<pair<int, int>>> prev1(h, vector<pair<int, int>> (w));

    dist1[ni][nj] = 0;
    deque<pair<int, int>> d = {{ni, nj}};
    while (!d.empty()) {
        auto [ci, cj] = d.front();
        d.pop_front();
        for (auto [di, dj] : diff) {
            if (ok(ci + di, cj + dj) && dist1[ci + di][cj + dj] == INF && ci + di >= ni && !(ci + di == ni && cj + dj == nj + 1) && a[ci + di][cj + dj] == '#') {
                dist1[ci + di][cj + dj] = dist1[ci][cj] + 1;
                prev1[ci + di][cj + dj] = {ci, cj};
                d.emplace_back(ci + di, cj + dj);
            }
        }
    }

    vector<vector<int>> dist2(h, vector<int> (w, INF));
    vector<vector<pair<int, int>>> prev2(h, vector<pair<int, int>> (w));

    dist2[ni][nj] = 0;
    d = {{ni, nj}};
    while (!d.empty()) {
        auto [ci, cj] = d.front();
        d.pop_front();
        for (auto [di, dj] : diff) {
            if (ok(ci + di, cj + dj) && dist2[ci + di][cj + dj] == INF && ci + di >= ni && !(ci + di == ni && cj + dj == nj - 1) && a[ci + di][cj + dj] == '#') {
                dist2[ci + di][cj + dj] = dist2[ci][cj] + 1;
                prev2[ci + di][cj + dj] = {ci, cj};
                d.emplace_back(ci + di, cj + dj);
            }
        }
    }

    int bi = -1, bj = -1;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (!(i == ni && j == nj) && a[i][j] == '#' && ((bi == -1 && bj == -1) || dist1[i][j] + dist2[i][j] < dist1[bi][bj] + dist2[bi][bj])) {
                bi = i, bj = j;
            }
        }
    }

    vector<string> ans(h, string(w, '.'));
    ans[ni][nj] = '#';
    int i, j;
    i = bi, j = bj;
    while (i != ni || j != nj) {
        ans[i][j] = '#';
        auto [nni, nnj] = prev1[i][j];
        i = nni, j = nnj;
    }
    i = bi, j = bj;
    while (i != ni || j != nj) {
        ans[i][j] = '#';
        auto [nni, nnj] = prev2[i][j];
        i = nni, j = nnj;
    }

    for (auto &el : ans) {
        cout << el << '\n';
    }
}

int32_t main() {
#ifdef DDD
    freopen("../input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    solve();
}