#include <bits/stdc++.h>

using namespace std;
#define int long long

const int INF = 1e16, MOD = 1e9 + 7;

vector<vector<pair<int, int>>> g;

pair<vector<int>, vector<int>> dijkstra(int start, int n) {
    set<pair<int, int>> q = {{0, start}};
    vector<int> dist(n, INF), dp(n, 0), used(n);
    dist[start] = 0;
    dp[start] = 1;
    while (!q.empty()) {
        auto [cost, u] = *q.begin();
        q.erase(q.begin()), used[u] = 1;
        for (auto [v, w] : g[u]) {

            if (used[v] == 1) continue;
            q.erase({dist[v], v});
            int now = cost + w;
            if (now == dist[v]) dp[v] = (dp[v] + dp[u]) % MOD;
            else if (now < dist[v]) dp[v] = dp[u], dist[v] = now;
            q.insert({ dist[v], v});
        }
    }
    return {dist, dp};
}

struct triple {
    int a, b, c;
};

signed main() {
    int n, m;
    cin >> n >> m;
    int start, finish, L;
    cin >> start >> finish >> L;
    start--, finish--;
    g.resize(n);
    vector<triple> edge;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c, a--, b--;
        g[a].push_back({b, c}), g[b].push_back({a, c});
        edge.push_back({a, b, c}), edge.push_back({b, a, c});
    }
    auto[dist_start, dp_start] = dijkstra(start, n);
    auto[dist_finish, dp_finish] = dijkstra(finish, n);
    for (int i = 0; i < n; ++i) dp_start[i] %= MOD, dp_finish[i] %= MOD;
    int ans = 0;
    if (L == dist_start[finish]) {
        cout << dp_start[finish] % MOD << endl;
        return 0;
    }
    for (triple x : edge) {
        int a = x.a, b = x.b, w = x.c;
        if (a == finish) continue;
        if (dist_start[a] + dist_finish[a] == dist_start[finish]) {
            if (w + dist_start[a] + dist_finish[b] == L) {
//                cout << a << " " << b << " " << w << endl;
                ans += dp_start[a] * dp_finish[b] % MOD;
            }
        }
        ans %= MOD;
    }
    cout << ans << endl;
}
