//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define ll long long

const int mod = 1e9 + 7;
const int MX = 1e9;

vector<vector<char>> ans;

void bfs(vector<string> a, pair<int, int> s, pair<int, int> t){
    int n = a.size(), m = a[0].size();
    queue<pair<int, int> > q;
    vector<vector<int> > dist(n, vector<int> (m, MX));
    vector<vector<pair<int, int>> > pred(n, vector<pair<int, int> > (m, {-1, -1}));
    dist[s.first][s.second] = 0;
    q.push(s);
    while(!q.empty()){
        auto v = q.front();
        q.pop();
        int x = v.first, y = v.second;
        if(x && a[x - 1][y] == '#' && dist[x - 1][y] == MX){
            dist[x - 1][y] = dist[x][y] + 1;
            pred[x - 1][y] = {x, y};
            q.push({x - 1, y});
        }
        if(x + 1 < n && a[x + 1][y] == '#' && dist[x + 1][y] == MX){
            dist[x + 1][y] = dist[x][y] + 1;
            pred[x + 1][y] = {x, y};
            q.push({x + 1, y});
        }
        if(y && a[x][y - 1] == '#' && dist[x][y - 1] == MX){
            dist[x][y - 1] = dist[x][y] + 1;
            pred[x][y - 1] = {x, y};
            q.push({x, y - 1});
        }
        if(y + 1 < m && a[x][y + 1] == '#' && dist[x][y + 1] == MX){
            dist[x][y + 1] = dist[x][y] + 1;
            pred[x][y + 1] = {x, y};
            q.push({x, y + 1});
        }
    }
    int x = t.first, y = t.second;
    while(x != s.first || y != s.second){
        ans[x][y] = '#';
        auto now = pred[x][y];
        x = now.first;
        y = now.second;
    }
    ans[x][y] = '#';
}

vector<vector<bool> > used;
vector<string> a;
int n, m;

void dfs(int x, int y) {
    if (x < 0 || x >= n || y < 0 || y >= m)
        return;
    if (used[x][y] || a[x][y] == '#')
        return;
    used[x][y] = 1;
    dfs(x - 1, y);
    dfs(x, y - 1);
    dfs(x + 1, y);
    dfs(x, y + 1);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    used.resize(n, vector<bool>(m, false));
    for (int i = 0; i < n; ++i) {
        if (a[i][m - 1] == '.' && !used[i][m - 1])
            dfs(i, m - 1);
        if (a[i][0] == '.' && !used[i][0])
            dfs(i, 0);
    }
    for (int j = 0; j < m; ++j) {
        if (a[n - 1][j] == '.' && !used[n - 1][j])
            dfs(n - 1, j);
        if (a[0][j] == '.' && !used[0][j])
            dfs(0, j);
    }
    vector<pair<int, int> > good;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!used[i][j] && a[i][j] == '.')
                good.push_back({i, j});
        }
    }
    pair<int, int> leftmn, rightmn, leftmx, rightmx;
    leftmn = good[0];
    rightmx = good.back();
    for (int i = (int) good.size() - 1; i >= 0; --i) {
        if (good[i].first == good[0].first) {
            rightmn = good[i];
            break;
        }
    }
    for (int i = 0; i < (int) good.size(); ++i) {
        if (good[i].first == good.back().first) {
            leftmx = good[i];
            break;
        }
    }
    auto b = a;
    for (int i = leftmn.second; i >= 0; --i)
        b[leftmn.first][i] = '.';
    for (int i = leftmx.second; i >= 0; --i)
        b[leftmx.first][i] = '.';
    for (int i = rightmn.second; i < m; ++i)
        b[rightmn.first][i] = '.';
    for (int i = rightmx.second; i < m; ++i)
        b[rightmx.first][i] = '.';

    ans.resize(n, vector<char>(m,'.'));
    bfs(b, {leftmn.first - 1, leftmn.second - 1}, {rightmn.first - 1, rightmn.second + 1});
    bfs(b, {leftmx.first + 1, leftmx.second - 1}, {rightmx.first + 1, rightmx.second + 1});
    b = a;
    for (int i = leftmn.first; i >= 0; --i)
        b[i][leftmn.second] = '.';
    for (int i = leftmx.first; i <n; ++i)
        b[i][leftmx.second] = '.';
    for (int i = rightmn.first; i >= 0; --i)
        b[i][rightmn.second] = '.';
    for (int i = rightmx.first; i <n; ++i)
        b[i][rightmx.second] = '.';
    bfs(b, {leftmn.first - 1, leftmn.second - 1}, {leftmx.first + 1, leftmx.second - 1});
    bfs(b, {rightmn.first - 1, rightmn.second + 1}, {rightmx.first + 1, rightmx.second + 1});
    for(int i = 0;i<n;++i){
        for(int j =0;j<m;++j)
            cout << ans[i][j];
        cout << "\n";
    }
}
