#include <bits/stdc++.h>
#include <numeric>

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

using namespace std;

struct Value {
    int k;
    int ind;

    Value() {}
    Value(int k, int ind) : k(k), ind(ind) {}
};

bool operator < (const Value& a, const Value& b) {
    return a.k < b.k;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif

    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int& x : a) {
        cin >> x;
    }
    sort(all(a));
    n = unique(all(a)) - a.begin();
    a.resize(n);

    vector<pair<int, int>> segments;
    if (a[0] != 0) {
        segments.emplace_back(0, a[0] - 1);
    }
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] + 1 != a[i + 1]) {
            int l = a[i] + 1;
            int r = a[i + 1] - 1;
            segments.emplace_back(l, r);
        }
    }

    vector<Value> requests(q);
    for (int i = 0; i < q; ++i) {
        int k;
        cin >> k;
        requests[i] = {k, i};
    }
    sort(all(requests));
    vector<int> answer(q);

    int k = 0;
    int ind = 0;
    for (auto [l, r] : segments) {
        int len = r - l + 1;
        while ((ind != q) && (requests[ind].k <= k + len)) {
            answer[requests[ind].ind] = requests[ind].k - k + l - 1;
            ++ind;
        }
        k += len;
    }
    while (ind < q) {
        int cur = requests[ind].k - k;
        answer[requests[ind].ind] = a.back() + cur;
        ++ind;
    }
    for (int x : answer) {
        cout << x << ' ';
    }
}