#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

template<typename A, typename B>
string to_string(pair<A, B> p);


string to_string(string s) {
    return '"' + s + '"';
}

string to_string(const char *s) {
    return to_string((string) s);
}

string to_string(bool a) {
    return (a ? "true" : "false");
}

template<typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template<typename A>
string to_string(A v) {
    bool f = 1;
    string res = "{";
    for (auto x: v) {
        if (!f) res += ", ";
        res += to_string(x);
        f = 0;
    }
    res += "}";
    return res;
}

void debug_out() {
    cerr << endl;
}

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

#define sz(a)(ll)(a).size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pikachu push_back
#define pll pair<ll, ll>
#define pii pair<int, int>
typedef long long ll;
typedef long double ld;


void run();

signed main() {
#ifdef LOCAL
    freopen("file.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    run();
}

void solve();

const int P = 1'000'000'007;

void run() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}


vector<pair<int, int>> cycle;
vector<vector<int>> w;
int n, m, ar, ac, br, bc;

void print_dir(pair<int, int> f, pair<int, int> t){
    int dx = t.first - f.first;
    int dy = t.second - f.second;
    if (dx == -1){
        cout << "U";
    }
    if (dx == 1){
        cout << "D";
    }
    if (dy == -1){
        cout << "L";
    }
    if (dy == 1){
        cout << "R";
    }
}

void print(){
    debug(cycle);
    long long sum = 0;
    int ind1 = -1;
    int ind2 = -1;
    int sz = cycle.size();
//    debug("there");
//    debug(sz);
//    debug(w.size(), w[0].size());
//    debug(w);
    for (int i = 0; i < sz; ++i){
//        debug(i);
        auto [a, b] = cycle[i];
        if (a == ar && b == ac){
            ind1 = i;
        }
        if (a == br && b == bc){
            ind2 = i;
        }
    }
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            sum += w[i][j];
        }
    }
//    debug(sum);
//    debug(ind1 != -1);
//    debug(ind2 != -1);
    long long sum1 = 0;
    int ind = ind1;
    while (true){
        auto [a, b] = cycle[ind];
        sum1 += w[a][b];
        if (ind == ind2){
            break;
        }
        ind = (ind + 1) % sz;
    }
//    debug(sum1);
    if (sum1 * 2 > sum){
        ind = ind1;
        while (ind != ind2){
//            debug(ind);
            print_dir(cycle[ind], cycle[(ind + 1) % sz]);
            ind = (ind + 1) % sz;
        }
    } else{
        ind = ind1;
        while (ind != ind2){
            print_dir(cycle[ind], cycle[(sz + ind - 1) % sz]);
            ind = (ind - 1 + sz) % sz;
        }
    }
    cout << endl;
}

void solve() {
    cin >> n >> m >> ar >> ac >> br >> bc;
    w.assign(n, vector<int>(m));
    --ar;
    --ac;
    --br;
    --bc;
    cycle.resize(0);
    cycle.reserve(n * m);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> w[i][j];
        }
    }
    if (m % 2 == 0) {
        for (int i = 0; i < m; ++i) {
            cycle.push_back({0, i});
        }
        for (int i = m - 1; i >= 0; --i) {
            if (i % 2 == 0) {
                for (int j = n - 1; j > 0; --j) {
                    cycle.push_back({j, i});
                }
            } else {
                for (int j = 1; j < n; ++j) {
                    cycle.push_back({j, i});
                }
            }
        }
        print();
    } else {
        if (n % 2 == 0) {
            for (int i = 0; i < n; ++i) {
                cycle.push_back({i, 0});
            }
            for (int i = n - 1; i >= 0; --i) {
                if (i % 2 == 0) {
                    for (int j = m - 1; j > 0; --j) {
                        cycle.push_back({i, j});
                    }
                } else {
                    for (int j = 1; j < m; ++j) {
                        cycle.push_back({i, j});
                    }
                }
            }
            print();
        } else {
            for (int i = 0; i < n; ++i) {
                cycle.push_back({i, 0});
            }
            for (int i = n - 1; i > 1; --i) {
                if (i % 2 == 1) {
                    for (int j = m - 1; j > 0; --j) {
                        cycle.push_back({i, j});
                    }
                } else {
                    for (int j = 1; j < m; ++j) {
                        cycle.push_back({i, j});
                    }
                }
            }
            cycle.push_back({1, m - 1});
            for (int j = m - 2; j > 0; --j) {
                if (j % 2 == 1) {
                    cycle.push_back({1, j});
                    cycle.push_back({0, j});
                } else {
                    cycle.push_back({0, j});
                    cycle.push_back({1, j});
                }
            }
        }
        if (make_pair(ar, ac) != make_pair(0, m - 1) && make_pair(br, bc) != make_pair(0, m - 1)) {
            print();
            return;
        }
        if (make_pair(ar, ac) != make_pair(0, 0) && make_pair(br, bc) != make_pair(0, 0)) {
            for (int i = 0; i < cycle.size(); ++i){
                cycle[i].second = m - 1 - cycle[i].second;
            }
            print();
            return;
        }
        if (make_pair(ar, ac) != make_pair(n - 1, m - 1) && make_pair(br, bc) != make_pair(n - 1, m - 1)) {
            for (int i = 0; i < cycle.size(); ++i){
                cycle[i].first = n - 1 - cycle[i].first;
            }
            print();
            return;
        }
    }
}
