#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
#include <deque>

using namespace std;
typedef long long ll;
#define int long long

int n, m;
char a[1010][1010];
bool lake[1010][1010];
pair <int, int> s;

void dfslake(int x, int y)
{
	if (a[x][y] != '.') return;
	if (lake[x][y]) return;
	lake[x][y] = true;

	dfslake(x - 1, y);
	dfslake(x + 1, y);
	dfslake(x, y - 1);
	dfslake(x, y + 1);
}

int minx[1010];
int maxx[1010];
int miny[1010];
int maxy[1010];

vector <pair <int, int>> mb;

bool ins[1010][1010];

char ans[1010][1010];

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;

	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= m; ++j)
		{
			cin >> a[i][j];
			if (a[i][j] == '.' && a[i + 1][j] == '#')
			{
				s = { i, j };
			}
		}
	}
	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= m; ++j)
		{
			if (a[i][j] == '.' && a[i + 1][j] == '#')
			{
				s = { i, j };
				break;
			}
		}
	}
	dfslake(s.first, s.second);

	vector <pair <int, int>> lk;
	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= m; ++j)
		{
			if (lake[i][j])
			{
				lk.push_back({ i, j });
			}
		}
	}

	for (int i = 1; i <= n; ++i)
	{
		minx[i] = m + 1;
		maxx[i] = 0;
	}

	for (int i = 1; i <= m; ++i)
	{
		miny[i] = n + 1;
		maxy[i] = 0;
	}

	for (auto i : lk)
	{
		minx[i.first] = min(minx[i.first], i.second);
		maxx[i.first] = max(maxx[i.first], i.second);
		miny[i.second] = min(miny[i.second], i.first);
		maxy[i.second] = max(maxy[i.second], i.first);
	}

	for (int i = 1; i <= n; ++i)
	{
		if (minx[i] > maxx[i]) continue;
		for (int j = minx[i]; j <= maxx[i]; ++j) lake[i][j] = true;
	}

	for (int i = 1; i <= m; ++i)
	{
		if (miny[i] > maxy[i]) continue;
		for (int j = miny[i]; j <= miny[i]; ++j) lake[j][i] = true;
	}

	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= m; ++j)
		{
			if (a[i][j] != '#') continue;
			bool ok = false;
			for (int x = -1; x <= 1; ++x)
			{
				for (int y = -1; y <= 1; ++y)
				{
					if (lake[i + x][j + y])
					{
						ok = true;
						break;
					}
				}
				if (ok) break;
			}
			if (ok) mb.push_back({ i, j });
		}
	}


	for (int i = 1; i <= n; ++i)
	{
		minx[i] = m + 1;
		maxx[i] = 0;
	}

	for (int i = 1; i <= m; ++i)
	{
		miny[i] = n + 1;
		maxy[i] = 0;
	}


	for (auto i : mb)
	{
		minx[i.first] = min(minx[i.first], i.second);
		maxx[i.first] = max(maxx[i.first], i.second);
		miny[i.second] = min(miny[i.second], i.first);
		maxy[i.second] = max(maxy[i.second], i.first);
	}

	for (int i = 1; i <= n; ++i)
	{
		if (minx[i] > maxx[i]) continue;
		for (int j = minx[i]; j <= maxx[i]; ++j) ins[i][j] = true;
	}

	for (int i = 1; i <= m; ++i)
	{
		if (miny[i] > maxy[i]) continue;
		for (int j = miny[i]; j <= miny[i]; ++j) ins[j][i] = true;
	}

	for (int i = 0; i <= n + 1; ++i)
	{
		for (int j= 0; j <= m + 1; ++j)
		{
			ins[i][j] = !ins[i][j];
		}
	}

	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= m; ++j)
		{
			ans[i][j] = '.';
		}
	}

	for (auto i : mb)
	{
		bool ok = false;
		for (int x = -1; x <= 1; ++x)
		{
			for (int y = -1; y <= 1; ++y)
			{
				if (ins[i.first + x][i.second + y])
				{
					ok = true;
					break;
				}
			}
			if (ok) break;
		}

		if (ok) ans[i.first][i.second] = '#';
	}

	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= m; ++j)
		{
			cout << ans[i][j];
		}
		cout << '\n';
	}

	return 0;
}