#include <iostream>
#include <cmath>
#include <algorithm>
#include <map>
#include <vector>
#include <set>
#include <deque>
#include <random>
using namespace std;

typedef long long ll;

#define int ll

const int MOD = 1e9 + 7;

vector<vector<pair<int ,int>>> t;

void build(int v, int l, int r, vector<int>& arr) {
	if (l + 1 == r) {
		t[v].push_back({arr[l], l});
		return;
	}
	int mid = (l + r) / 2;
	build(2 * v + 1, l, mid, arr);
	build(2 * v + 2, mid, r, arr);
	t[v].resize(r - l);
	merge(t[2 * v + 1].begin(), t[2 * v + 1].end(), t[2 * v + 2].begin(), t[2 * v + 2].end(), t[v].begin());
}

int get_cnt(int v, int l, int r, int a, int b, int x) {
	if (b <= l || r <= a) {
		return 0;
	}
	if (a <= l && r <= b) {
		auto it = lower_bound(t[v].begin(), t[v].end(), make_pair( x, -1LL ));
		return t[v].end() - it;
	}
	int mid = (l + r) / 2;
	return get_cnt(2 * v + 1, l, mid, a, b, x) + get_cnt(2 * v + 2, mid, r, a, b, x);
}

pair<int, int> get_inds(int v, int l, int r, int a, int b, int x) {
	if (b <= l || r <= a) {
		return { -1, -1 };
	}
	if (a <= l && r <= b) {
		auto it = lower_bound(t[v].begin(), t[v].end(), make_pair(x, -1LL));
		int cnt = t[v].end() - it;
		if (cnt == 0) {
			return { -1, -1 };
		}
		if (cnt == 1) {
			return { it->second, -1 };
		}
		else {
			auto it1 = it;
			it1++;
			return { it->second, it1->second };
		}
	}
	int mid = (l + r) / 2;
	auto v1 = get_inds(2 * v + 1, l, mid, a, b, x);
	auto v2 = get_inds(2 * v + 2, mid, r, a, b, x);
	if (v1.second != -1) {
		return v1;
	}
	else if (v2.second != -1) {
		return v2;
	}
	else if (v1.first == -1) {
		return v2;
	}
	else if (v2.first == -1) {
		return v1;
	}
	else {
		return { v1.first, v2.first };
	}
}
mt19937 rnd(2223);
set <int> ob(set <int> p1, set <int> p2) {
	set <int> ns;
	for (auto x : p1) {
		if (p2.find(x) != p2.end()) {
			ns.insert(x);
		}
	}
	return ns;
}
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	vector <int> a;
	for (int i = 0; i < n; ++i) {
		a.push_back(i + 1);
	}
	vector <int> ans(n + 1);
	vector <pair <vector <int>, vector <int> >> b;
	vector <set <int> > vzm(n + 1);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (j != i) {
				vzm[i].insert(j + 1);
			}
		}
	}
	for (int zz = 0; zz < 3; ++zz) {
		shuffle(a.begin(), a.end(), rnd);
		vector <vector <int> > gr;
		int sq = sqrt(n);
		int z = rand() % sq + 1;
		int uk = 0;
		vector <int> used(n + 1);
		while (uk < n) {
			if (z > n - uk + 1) {
				for (int j = gr.size() - 1; j >= 0 && uk < n; --j) {
					gr[j].push_back(a[uk]);
					used[a[uk]] = j + 1;
					uk++;
					z--;
				}
				break;
			}
			else {
				vector <int> ngr;
				for (int j = 0; j < z; ++j) {
					ngr.push_back(a[uk]);
					used[a[uk]] = gr.size() + 1;
					uk++;
				}
				gr.push_back(ngr);
				
			}
			z = rnd() % sq + 1;
		}
		cout << gr.size() << endl;
		for (int i = 1; i <= n; ++i) {
			cout << used[i] << " ";
		}
		cout << endl;
		for (int i = 0; i < gr.size(); ++i) {
			int sz;
			cin >> sz;
			vector <int> mn;
			for (int j = 0; j < sz; ++j) {
				int x;
				cin >> x;
				mn.push_back(x);
			}
			int e = 0;
			for (int j = 0; j < gr.size(); ++j) {
				if (gr[j].size() == sz) {
					e = j;
					break;
				}
			}
			for (auto x : gr[e]) {
				set <int> cc;
				for (int j = 0; j < mn.size(); ++j) {
					cc.insert(mn[j]);
				}
				vzm[x - 1] = ob(vzm[x - 1], cc);
			} 
			b.push_back({ gr[e], mn });
		}
	}
	while (find(ans.begin() + 1, ans.end(), 0) != ans.end()) {
		for (int i = 0; i < n; ++i) {
			if (vzm[i].size() == 1) {
				auto it = vzm[i].begin();
				ans[i + 1] = (*it);
				for (int j = 0; j < n; ++j) {
					if (find(vzm[j].begin(), vzm[j].end(), ans[i + 1]) != vzm[j].end()) {
						vzm[j].erase(ans[i + 1]);
					}
				}
			}
		}
	}
	for (int i = 1; i <= n; ++i) {
		cout << ans[i] << " ";
	}
	cout << endl;
	/*int n;
	cin >> n;
	t.resize(4 * n);
	vector<int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	build(0, 0, n, arr);
	int q;
	cin >> q;
	while (q--) {
		int l, r;
		cin >> l >> r;
		l--, r--;
		if (l == r) {
			cout << arr[l] << '\n';
			continue;
		}
		int L = -1, R = 1e9 + 1;
		while (L + 1 < R) {
			int mid = (L + R) / 2;
			if (get_cnt(0, 0, n, l, r + 1, mid) > 2) {
				L = mid;
				continue;
			}
			if (get_cnt(0, 0, n, l, r + 1, mid) <= 1) {
				R = mid;
				continue;
			}
			pair<int, int> aaa = get_inds(0, 0, n, l, r + 1, mid);
			cout << mid << ' ' << aaa.first << ' ' << aaa.second << '\n';
			if ((aaa.second - aaa.first) % 2 == 0 || abs(aaa.second - aaa.first) == 1) {
				L = mid;
			}
			else {
				R = mid;
			}
		}
		cout << L << '\n';
	}*/
	
	
}
/*

4
3
1 2 4
1
3
3
3 4 1
1
2
3
1 2 4
1
3

*/