#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <deque>
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define ve vector
#define ft first
#define sd second
using namespace std;
ll MOD = 1e9 + 7;
ll INF = 1e18;

ll n, m;
vector<string> g;
vector<ll> dx = {0, 0, 1, -1};
vector<ll> dy = {1, -1, 0, 0};

set<pair<ll, ll>> to_ans;

bool in(ll x, ll y) {
    if (min(x, y) < 0 || x >= n || y >= m) return false;
    return true;
}

void bfs1(ll x, ll y) {
    g[x][y] = '1';

    for (ll k = 0; k < 4; ++k) {
        ll new_x = x + dx[k];
        ll new_y = y + dy[k];

        if (!in(new_x, new_y) || g[new_x][new_y] != '.') continue;

        bfs1(new_x, new_y);
    }
}

ll real_bfs(ll x1, ll y1, ll x2, ll y2) {
    vector<vector<ll>> dist(n, vector<ll> (m, INF));

    dist[x1][y1] = 0;

    deque<pair<ll, ll>> now;
    now.push_back({x1, y1});

    while (now.size()) {
        auto gh = now[0];
        now.pop_front();

        for (ll k = 0; k < 4; ++k) {
            ll new_x = gh.first + dx[k];
            ll new_y = gh.second + dy[k];

            if (!in(new_x, new_y) || g[new_x][new_y] != '#' || dist[new_x][new_y] != INF) continue;

            dist[new_x][new_y] = dist[gh.first][gh.second] + 1;
            now.push_back({new_x, new_y});
        }
    }

    ll now_x = x2, now_y = y2;

    while (now_x != x1 || now_y != y1) {
        to_ans.insert({now_x, now_y});

        for (ll k = 0; k < 4; ++k) {
            ll new_x = now_x + dx[k];
            ll new_y = now_y + dy[k];

            if (!in(new_x, new_y) || g[new_x][new_y] != '#' || dist[new_x][new_y] != dist[now_x][now_y] - 1) continue;

            now_x = new_x;
            now_y = new_y;
            break;
        }
    }

    return dist[x2][y2];
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    g.resize(n);
    for (ll i = 0; i < n; ++i) cin >> g[i];

    for (ll i = 0; i < n; ++i) {
        if (g[i][0] == '.') bfs1(i, 0);
        if (g[i][m - 1] == '.') bfs1(i, m - 1);
    }
    for (ll i = 0; i < m; ++i) {
        if (g[0][i] == '.') bfs1(0, i);
        if (g[n - 1][i] == '.') bfs1(m - 1, i);
    }

    pair<ll, ll> left = {INF, INF};
    pair<ll, ll> right = {-INF, -INF};
    pair<ll, ll> up = {INF, INF};
    pair<ll, ll> down = {-INF, -INF};

    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            if (g[i][j] == '.') {
                if (left.second > j) left = {i, j};
                if (right.second < j) right = {i, j};
                if (up.first > i) up = {i, j};
                if (down.first < i) down = {i, j};
            }
        }
    }

    vector<string> iznach = g;

    for (ll i = down.first + 1; i < n; ++i) {
        g[i][down.second] = '.';
    }

    ll ans = real_bfs(left.first, left.second - 1, right.first, right.second + 1);

    g = iznach;

    for (ll i = 0; i < up.first; ++i) {
        g[i][up.second] = '.';
    }

    ans += real_bfs(left.first, left.second - 1, right.first, right.second + 1);

    vector<string> rt(n);

    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) rt[i] += '.';
    }

    rt[left.first][left.second - 1] = '#';

    for (auto i : to_ans) rt[i.first][i.second] = '#';

    for (auto i : rt) cout << i << '\n';
    return 0;
}

/*
4 6
######
#.#.##
#...#.
#####.
 */
