#include <bits/stdc++.h>
using namespace std;

const double eps = 1e-10;
typedef long long ll;
typedef pair< ll, ll> pll;
typedef pair<int, int> pii;
const int maxN = 1000 + 9;
const ll MOD = 1e9 + 7;
char s[maxN][maxN];
int lake[maxN][maxN];
int n, m;

void dfs(int x, int y) {
    if (!lake[x][y]) return;
    lake[x][y] = 0;
    for (int i = 0; i <= 1; ++i) {
        for (int j = -1; j <= 1; j += 2) {
            int x1 = x;
            int y1 = y;
            if (i) swap(x1, y1);
            x1 += j;
            if (i) swap(x1, y1);
            if (x1 >= 0 && x1 < n && y1 >= 0 && y1 < m && s[x1][y1] == '.') {
                dfs(x1, y1);
            }
        }
    }
}

int dist[maxN][maxN];
pair<int, int> pr[maxN][maxN];
set<pair<int, int>> ans;

void bfs(pair<int, int> from, pair<int, int> to, int dir) {
    fill(dist[0], dist[0] + maxN * maxN, 1e9);
    deque<pair<int, int>> de = {{from.first, from.second + dir}};
    dist[from.first][from.second] = 0;
    dist[from.first][from.second + dir] = 1;
    pr[from.first][from.second + dir] = from;
    while (!de.empty()) {
        auto nw = de.front();
        de.pop_front();
        int x = nw.first;
        int y = nw.second;
        for (int i = 0; i <= 1; ++i) {
            for (int j = -1; j <= 1; j += 2) {
                int x1 = x;
                int y1 = y;
                if (i) swap(x1, y1);
                x1 += j;
                if (i) swap(x1, y1);
                if (x1 >= 0 && x1 < n && y1 >= 0 && y1 < m && s[x1][y1] == '#' && dist[x][y] + 1 < dist[x1][y1]) {
                    dist[x1][y1] = dist[x][y] + 1;
                    de.push_back({x1, y1});
                    pr[x1][y1] = {x, y};
                }
            }
        }
    }
    auto nw = to;
    while (nw != from) {
        ans.insert(nw);
        nw = pr[nw.first][nw.second];
    }
    ans.insert(from);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
     cin >> n >> m;
    for(int i = 0; i < n; ++i) {
        cin >> s[i];
        for (int j = 0; j < m; ++j) {
            if (s[i][j] != '#') lake[i][j] = 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i == 0 || i == n - 1 || j == 0 || j == m - 1) {
                if (s[i][j] == '.') {
                    dfs(i, j);
                }
            }
        }
    }
    pair<int, int> up{1e9, 1e9};
    pair<int, int> down{-1, -1};
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (lake[i][j] && i < up.first) up = {i, j};
            if (lake[i][j]) down = {i, j};
        }
    }
    up.first -= 1;
    down.first += 1;
    bfs(up, down, 1);
    bfs(up, down, -1);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (ans.find({i, j}) != ans.end()) {
                cout << '#';
            } else {
                cout << '.';
            }
        }
        cout << '\n';
    }
}
/*

4 6
######
#.#.##
#...#.
#####.


4 7
#######
#.###.#
#.....#
#######

 */