#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

ld eps = 1e-7;

ostream &operator<<(ostream &out, vector<int> &vec) {
    for (int el: vec) {
        out << el << ' ';
    }
    return out;
}

ostream &operator<<(ostream &out, vector<bool> &vec) {
    for (bool el: vec) {
        if (el)
            out << '#';
        else
            out << '.';
    }
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &vec) {
    for (T el: vec) {
        out << el << '\n';
    }
    return out;
}

#define int long long

const ll MOD = 1e9 + 7;
const ll INF = 1e18, mod = 1e9 + 7;
const int N = 410;

void update(int x, int y, vector<vector<ll>>& f, ll val) {
    for (int i = x; i < N; i |= (i + 1)) {
        for (int j = y; j < N; j |= (j + 1)) {
            f[i][j] = (f[i][j] + val) % MOD;
        }
    }
}

ll get(int x, int y, vector<vector<ll>>& f) {
    ll res = 0;
    for (int i = x; i < N; i = ((i + 1) & i) - 1) {
        for (int j = x; j < N; j = ((j + 1) & j) - 1) {
            res += f[i][j];
        }
    }
    return res;
}

vector<vector<pair<int, int>>> g;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //freopen("input.txt", "r", stdin);
    /*
    int n, m;
    cin >> n >> m;
    vector<vector<ll>> f1(N, vector<ll> (N, 0));
    vector<vector<ll>> f2(N, vector<ll> (N, 0));
    int max_k = min((n + 1) / 2, (m + 1) / 2);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            update(i, j, f1, (i + 1) * (j + 1));
            update(i, j, f2, (i + 1) * (j + 1));
        }
    }
    for (int k = 0; k < max_k; ++k) {
        for (int i = n - 1; i >= 0; --i) {
            for (int j = m - 1; j >= 0; ++j) {

            }
        }
    }
    cout << f1[n][m];
    */

    int n, m, s, t, l;
    cin >> n >> m >> s >> t >> l;
    s--, t--;
    g.resize(n);
    int u, v, cost;
    for (int i = 0; i < m; i++) {
        cin >> u >> v >> cost;
        u--, v--;
        g[u].push_back({v, cost});
        g[v].push_back({u, cost});
    }
    vector<int> dist1(n, INF), dist2(n, INF), cnt1(n), cnt2(n), p1(n, -1), p2(n, -1);
    dist1[s] = 0;
    set<pair<int, int>> st;
    st.insert({0, s});
    cnt1[s] = 1;
    cnt2[t] = 1;
    while (!st.empty()) {
        auto now = *st.begin();
        v = now.second;
        st.erase(st.begin());
        for (auto gg: g[v]) {
            int to = gg.first;
            cost = gg.second;
            if (dist1[to] > dist1[v] + cost) {
                st.erase({dist1[to], to});
                dist1[to] = dist1[v] + cost;
                cnt1[to] = cnt1[v];
                cnt1[to] %= mod;
                p1[to] = v;
                st.insert({dist1[to], to});
            }
            else if (dist1[to] == dist1[v] + cost) {
                cnt1[to] += cnt1[v];
                cnt1[to] %= mod;
            }
        }
    }

    dist2[t] = 0;
    st.insert({0, t});
    while (!st.empty()) {
        auto now = *st.begin();
        v = now.second;
        st.erase(st.begin());
        for (auto gg: g[v]) {
            int to = gg.first;
            cost = gg.second;
            if (dist2[to] > dist2[v] + cost) {
                st.erase({dist2[to], to});
                dist2[to] = dist2[v] + cost;
                cnt2[to] = cnt2[v];
                cnt2[to] %= mod;
                p2[to] = v;
                st.insert({dist2[to], to});
            }
            else if (dist2[to] == dist2[v] + cost) {
                cnt2[to] += cnt2[v];
                cnt2[to] %= mod;
            }
        }
    }
    //cout << dist1 << dist2;
    int best = dist1[t];
    int ans = 0;
    if (l == best) {
        cout << cnt1[t];
        return 0;
    }
    //cout << cnt1 << endl;
    for (v = 0; v < n; v++) {
        for (auto gg: g[v]) {
            int to = gg.first;
            if (dist1[v] + dist2[v] == best) {
                if (dist1[v] + gg.second + dist2[to] == l) {
                    ans = (ans + (cnt1[v] * cnt2[to]) % mod) % mod;
                }
            }
        }
    }
    cout << ans;

}
