#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 2e5 + 3;
const ll INF = 1e18, mod = 1e9 + 7;

int n, m;
vector<vector<pair<int, ll>>> g;
vector<vector<int>> dags, dagt;
vector<ll> ds, dt, dps, dpt;
vector<int> degs, degt;

vector<ll> djikstra(int st){
    vector<ll> d(n + 1, INF);
    d[st] = 0;
    set<pair<ll, int>> s;
    s.insert({0, st});

    while(!s.empty()){
        int v = s.begin()->second;
        int dist = s.begin()->first;
        s.erase(s.begin());
        for(auto i : g[v]){
            if(dist + i.second < d[i.first]){
                s.erase({d[i.first], i.first});
                d[i.first] = dist + i.second;
                s.insert({d[i.first], i.first});
            }
        }
    }

    return d;
}

vector<bool> us;

void bfss(int st){
    queue<int> q;
    q.push(st);
    dps[st] = 1;
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(auto i : dags[v]){
            degs[i]--;
            dps[i] += dps[v];
            dps[i] %= mod;
            if(degs[i] == 0){
                q.push(i);
            }
        }
    }
}

void bfst(int st){
    queue<int> q;
    q.push(st);
    dpt[st] = 1;
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(auto i : dagt[v]){
            degt[i]--;
            dpt[i] += dpt[v];
            dpt[i] %= mod;
            if(degt[i] == 0){
                q.push(i);
            }
        }
    }
}

ll ans = 0;
ll L;
vector<bool> good;

void dfs(int v, int t) {
    us[v] = true;
    if (v == t) {
        good[v] = true;
        return;
    }

    for (auto i: dags[v]) {
        if (us[i]) {
            if (good[i]) good[v] = true;
            continue;
        }
        dfs(i, t);
        if (good[i]) good[v] = true;
    }
}



int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int s, t;
    cin >> n >> m;
    cin >> s >> t >> L;
    g.resize(n + 1);
    dags.resize(n + 1);
    dagt.resize(n + 1);
    dps.resize(n + 1);
    dpt.resize(n + 1);
    us.resize(n + 1);
    good.resize(n + 1);
    degs.resize(n + 1);
    degt.resize(n + 1);

    for(int i = 0; i < m; ++i){
        int a, b;
        ll c;
        cin >> a >> b >> c;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }

    ds = djikstra(s);
    dt = djikstra(t);

    for(int i = 1; i <= n; ++i){
        for(auto j : g[i]){
            if(ds[i] + j.second == ds[j.first]){
                dags[i].push_back(j.first);
                degs[j.first]++;
            }
            if(dt[i] + j.second == dt[j.first]){
                dagt[i].push_back(j.first);
                degt[j.first]++;
            }
        }
    }

//    for(int i = 1; i <= n; ++i){
//        cout << i << " ";
//        for(auto j : dagt[i]){
//            cout << j << " ";
//        }
//        cout << "\n";
//    }

    bfss(s);
    bfst(t);
    dfs(s, t);

    if(ds[t] == L){
        cout << dps[t];
        return 0;
    }

    for(int i = 1; i <= n; ++i){
        if(good[i] && i != t){
            for(auto j : g[i]){
                if(ds[i] + j.second + dt[j.first] == L){
                    ans += dps[i] * dpt[j.first];
                    ans %= mod;
                }
            }
        }
    }

    cout << ans;
}

