from functools import lru_cache


@lru_cache(maxsize=1000000)
def rect(h, w):
    if min(h, w) <= 2:
        s = w * (w + 1) * (w + 2) * h * (h + 1) * (h + 2) // 36
        c = w * (w + 1) * h * (h + 1) // 4
        return s, c
    else:
        s = (w * (w + 1) * (w + 2) * h * (h + 1) * (h + 2) // 36) % r
        c = (w * (w + 1) * h * (h + 1) // 4) % r
        for h_ in range(3, h + 1):
            for w_ in range(3, w + 1):
                s_, c_ = rect(min(h_ - 2, w_ - 2), max(h_ - 2, w_ - 2))
                s += ((h_ * w_ * c_ + s_) * (h - h_ + 1) * (w - w_ + 1)) % r
                c += (c_ * (h - h_ + 1) * (w - w_ + 1)) % r
        return s % r, c % r


def base(h, w):
    if min(h, w) <= 2:
        return h * w
    else:
        s_, c_ = rect(h - 2, w - 2)
        return ((c_ + 1) * w * h + s_) % r


r = 1_000_000_007
height, width = map(int, input().split())
print(base(height, width))
