#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<pll> vpll;
typedef long double ld;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;

vector<pair<ll, ll>> get_dist(ll s, const vector<vector<pair<ll, ll>>> &g) {
    vector<pair<ll, ll>> dist((ll) g.size(), {INF, 0});
    dist[s] = {0, 1};
    set<pair<ll, ll>> st;
    st.insert({0, s});
    while (!st.empty()) {
        auto [d, v] = *st.begin();
        st.erase(st.begin());
        for (auto [u, w] : g[v]) {
            if (dist[u].first == d + w) {
                dist[u].second += dist[v].second;
                dist[u].second %= MOD;
            } else if (dist[u].first > d + w) {
                st.erase({dist[u].first, u});
                dist[u] = {d + w, dist[v].second};
                st.insert({dist[u].first, u});
            }
        }
    }
    return dist;
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll n, m;
    cin >> n >> m;
    ll s, t;
    ll l;
    cin >> s >> t >> l;
    vector<vector<pair<ll, ll>>> g(n);
    for (ll i = 0; i < m; ++i) {
        ll v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        g[v].emplace_back(u, w);
        g[u].emplace_back(v, w);
    }
    s--;
    t--;
    vector<pair<ll, ll>> dist_s = get_dist(s, g);
    /*for (auto [i, j] : dist_s) {
        cout << i << ' ' << j << '\n';
    }
    cout << endl;*/
    vector<pair<ll, ll>> dist_t = get_dist(t, g);
    ll L = dist_s[t].first;
    if (L == l) {
        cout << dist_s[t].second;
        return 0;
    }
    ll ans = 0;
    for (ll i = 0; i < n; ++i) {
        if (dist_s[i].first + dist_t[i].first == L) {
            for (auto [u, w] : g[i]) {
                if (w + dist_s[i].first + dist_t[u].first == L) {
                    continue;
                }
                if (w + dist_s[i].first + dist_t[u].first == l) {
                    ans += (ll) dist_s[i].second * dist_t[u].second % MOD;
                    ans %= MOD;
                    //cout << i << ' ' << u << '\n';
                }
            }
        }
    }
    cout << ans;
}