#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <random>

using namespace std;

#ifdef KROL
#define dbg(x) cerr << #x << ":\n " << x;
#else
#define dbg(x);
#endif

typedef long long ll;
typedef long double ld;

#define int ll
#define sz(x) int(x.size())

const ll inf = 1e16;

//void solve() {
//	int n, b, c;
//	cin >> n >> b >> c;
//
//	vector<int> x(n), p(n);
//	for (int i = 0; i < n; ++i) {
//		cin >> x[i] >> p[i];
//	}
//
//	int mc = p[0];
//	for (int i = 0; i < n - 1; ++i) {
//		int dx = x[i + 1] - x[i];
//		if (dx <= c) {
//			c -= dx;
//			mc = min(mc, p[i + 1]);
//		} else {
//			if (dx > b / mc + c) {
//				cout << x[i] + b / mc + c;
//
//				return;
//			} else {
//				dx -= c;
//				c = 0;
//				b -= dx * mc;
//				mc = min(mc, p[i + 1]);
//			}
//		}
//	}
//
//	cout << x[n - 1] + c;
//}

pair<ll, ll> merge(pair<ll, ll> a, pair<ll, ll> b) {
	return { max(a.first, b.first), min(a.second, b.second) };
}

ll get(vector<ll> a) {
	int n = a.size();
	vector<pair<ll, ll>> pr(n + 1), sf(n + 1);
	pr[0] = { -inf, inf };
	for (int i = 1; i < n; i++) {
		pr[i] = pr[i - 1];
		if (i - 1 > n - 1 - (i - 1)) continue;
		ll bf = a[i - 1] + a[n - 1 - (i - 1)];
		pr[i] = merge(pr[i - 1], { bf, bf });
	}
	sf[n - 1] = { -inf, inf };
	for (int i = n - 2; i >= 0; i--) {
		sf[i] = sf[i + 1];
		if (i + 1 > n - i - 1) continue;
		ll af = a[i + 1] + a[n - i - 1];
		sf[i] = merge(sf[i + 1], { af, af });
	}
	ll ans = inf;
	for (int i = 0; i < n; i++) {
		ll mx = max(pr[i].first, sf[i].first);
		ll mn = min(pr[i].second, sf[i].second);
		if (n - 1 - i < i) continue;
		ans = min(ans, mx - mn);
	}
	return ans;
}

void solve() {
	int n;
	cin >> n;
	vector<ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	sort(a.begin(), a.end());
	ll ans = get(a);
	reverse(a.begin(), a.end());
	ans = min(ans, get(a));
	cout << ans << '\n';
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);
	cout << fixed << setprecision(20);

	int T = 1;
	//cin >> T;

	for (int t = 1; t <= T; ++t) {
		solve();
	}
}