#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <random>

using namespace std;

#ifdef KROL
#define dbg(x) cerr << #x << ":\n " << x << "\n";
#else
#define dbg(x);
#endif

typedef long long ll;
typedef long double ld;

#define int ll
#define sz(x) int(x.size())

const ll inf = 1e16;

void solve() {
	int n, b, c;
	cin >> n >> b >> c;

	vector<int> x(n), p(n);
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> p[i];
	}

	vector<int> rl(n, n);
	vector<int> st;
	for (int i = 0; i < n; ++i) {
		while (!st.empty() && p[i] <= p[st.back()]) {
			rl[st.back()] = i;
			st.pop_back();
		}
		st.push_back(i);
	}

	int i = 0, ans = 0, li = 0;
	while (true) {
		int fb = x[i] + min(c, li + b / p[i]);
		ans = max(ans, fb);
		if (i == n - 1 || fb < x[i + 1]) break;
		if (rl[i] == n || fb < x[rl[i]]) {
			int buy = min(c - li, b / p[i]);
			li += buy;
			li -= x[i + 1] - x[i];
			b -= buy * p[i];
			++i;
		} else {
			int buy = max(0ll, (x[rl[i]] - x[i] - li));
			li += buy;
			li -= x[rl[i]] - x[i];
			b -= buy * p[i];
			i = rl[i];
		}
	}

	cout << ans << '\n';
}

//const int maxn = 2e5 + 10;
//const int mod = 1e9 + 7;
//vector<pair<int, ll>> g[maxn];
//ll dpt[maxn], dps[maxn];
//
//vector<ll> dijkstra(int n, int s) {
//	vector<ll> d(n, inf);
//	d[s] = 0;
//	set<pair<ll, int>> q;
//	q.insert({ 0, s });
//	while (!q.empty()) {
//		auto [dist, v] = (*q.begin());
//		q.erase(q.begin());
//		if (d[v] != dist) continue;
//		for (auto& [u, w] : g[v]) {
//			if (d[u] > d[v] + w) {
//				d[u] = d[v] + w;
//				q.insert({ d[u], u });
//			}
//		}
//	}
//	return d;
//}
//vector<ll> ds, dt;
//
//void dfs1(int v) {
//	if (dpt[v] != -1) return;
//	dpt[v] = 0;
//	for (auto& [u, w] : g[v]) {
//		if (dt[v] == dt[u] + w) {
//			dfs1(u);
//			dpt[v] = (dpt[u] + dpt[v]) % mod;
//		}
//	}
//}
//
//void dfs2(int v) {
//	if (dps[v] != -1) return;
//	dps[v] = 0;
//	for (auto& [u, w] : g[v]) {
//		if (ds[v] + w == ds[u]) {
//			dfs2(u);
//			dps[v] = (dps[u] + dps[v]) % mod;
//		}
//	}
//}
//
//void solve() {
//	int n, m;
//	cin >> n >> m;
//	int s, t, L;
//	cin >> s >> t >> L;
//	s--, t--;
//
//	for (int i = 0; i < m; i++) {
//		int v, u, w;
//		cin >> v >> u >> w;
//		v--, u--;
//		g[v].push_back({ u, w });
//		g[u].push_back({ v, w });
//	}
//	ds = dijkstra(n, s);
//	dt = dijkstra(n, t);
//	int sh = ds[t];
//	fill(dpt, dpt + n, -1);
//	fill(dps, dps + n, -1);
//	dpt[t] = 1;
//	dps[s] = 1;
//	for (int v = 0; v < n; v++) {
//		if (dpt[v] == -1) dfs1(v);
//		if (dps[v] == -1) dfs2(v);
//	}
//	ll ans = 0;
//	for (int v = 0; v < n; v++) {
//		for (auto& [u, w] : g[v]) {
//			if (u < v) continue;
//			if (ds[v] + w + dt[u] == L) {
//				ll add = (dps[v] * dpt[u]) % mod;
//				ans = (ans + add) % mod;
//			}
//		}
//	}
//	cout << ans << '\n';
//}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);
	cout << fixed << setprecision(20);

	int T = 1;
	//cin >> T;

	for (int t = 1; t <= T; ++t) {
		solve();
	}
}