#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define sz(v) v.size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
const int mod = 1e9 + 7;

pair<ll, ll> operator+(pair<ll, ll> a, pair<ll, ll> b) {
    return {(a.first + b.first) % mod, (a.second + b.second) % mod};
}
pair<ll, ll> operator-(pair<ll, ll> a, pair<ll, ll> b) {
    pair<ll, ll> c = {(a.first - b.first) % mod, (a.second - b.second) % mod};
    if (c.first < 0) c.first += mod;
    if (c.second < 0) c.second += mod;
    return c;
}
pair<ll, ll> operator*(pair<ll, ll> a, ll x) {
    x %= mod;
    return {(a.first * x) % mod, (a.second * x) % mod};
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int h, w;
    cin >> h >> w;
    vector<vector<pair<ll, ll>>> dp(h + 1, vector<pair<ll, ll>>(w + 1));

    vector<vector<pair<ll, ll>>> pref(h + 1, vector<pair<ll, ll>>(w + 1));
    vector<vector<pair<ll, ll>>> pref_h(h + 1, vector<pair<ll, ll>>(w + 1));
    vector<vector<pair<ll, ll>>> pref_w(h + 1, vector<pair<ll, ll>>(w + 1));
    vector<vector<pair<ll, ll>>> pref_hw(h + 1, vector<pair<ll, ll>>(w + 1));

    for (ll i = 1; i <= h; i++) {
        for (ll j = 1; j <= w; j++) {
            if (i <= 2 || j <= 2) {
                dp[i][j] = {i * j, 1};
            } else {
                dp[i][j] = (pref[i - 2][j - 2] * (i - 1) * (j - 1)) -
                        (pref_h[i - 2][j - 2] * (j - 1)) -
                        (pref_w[i - 2][j - 2] * (i - 1)) +
                        pref_hw[i - 2][j - 2];

                dp[i][j].second++;
                dp[i][j].first = (dp[i][j].first + i * j * dp[i][j].second) % mod;
            }

            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + dp[i][j];

            pref_h[i][j] = pref_h[i - 1][j] + pref_h[i][j - 1] - pref_h[i - 1][j - 1] + (dp[i][j] * i);

            pref_w[i][j] = pref_w[i - 1][j] + pref_w[i][j - 1] - pref_w[i - 1][j - 1] + (dp[i][j] * j);

            pref_hw[i][j] = pref_hw[i - 1][j] + pref_hw[i][j - 1] - pref_hw[i - 1][j - 1] + (dp[i][j] * i * j);
        }
    }

    cout << dp[h][w].first << '\n';

    return 0;
}
