#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <fstream>
using namespace std;
#define int long long
#define all(i) i.begin(), i.end()
#define For(i, n) for(int i = 0; i < n; ++i)
#define For3(i, s, n) for(int i = s; i < n; ++i)
#define For4(i, s, n, c) for(int i = s; (i < n) == (c > 0); i += c)
const int INF = 1e12;

struct Node
{
	int prior, mnInd = INF, myInd;
	pair<int, int> val;
	Node* l, * r;

	void print()
	{
		if (l) l->print();
		cout << val.first << " " << myInd << "\n";
		if (r) r->print();
	}
};
int getRand()
{
	return rand() * RAND_MAX + rand();
}
Node* newNode(int x, int ind)
{
	return new Node{ getRand(), ind, ind, make_pair(x, ind), 0, 0 };
}
int getMn(Node* nd)
{
	return nd ? nd->mnInd : INF;
}
void update(Node* nd)
{
	nd->mnInd = min(min(getMn(nd->l), getMn(nd->r)), nd->myInd);
}
Node* merge(Node* l, Node* r)
{
	if (!l) return r;
	if (!r) return l;

	if (l->prior < r->prior)
	{
		l->r = merge(l->r, r);
		update(l);
		return l;
	}
	else
	{
		r->l = merge(l, r->l);
		update(r);
		return r;
	}
}

pair<Node*, Node*> split(Node* nd, pair<int, int> x)
{
	if (!nd) return { 0, 0 };
	if (x < nd->val)
	{
		auto p = split(nd->l, x);
		nd->l = p.second;
		update(nd);
		return { p.first, nd };
	}
	else
	{
		auto p = split(nd->r, x);
		nd->r = p.first;
		update(nd);
		return { nd, p.second };
	}
}

struct Fenv
{
	Node* root;

	void erase(pair<int, int> x)
	{
		auto p1 = split(root, make_pair(x.first, x.second - 1));
		auto p2 = split(p1.second, x);
		delete(p2.first);
		root = merge(p1.first, p2.second);
	}

	void add(int x, int ind)
	{
		auto p1 = split(root, make_pair(x, ind));
		root = merge(merge(p1.first, newNode(x, ind)), p1.second);
	}

	int getInd(int x)
	{
		auto p = split(root, make_pair(x, INF));
		int ans = getMn(p.first);
		root = merge(p.first, p.second);
		return ans;
	}

	void print()
	{
		if (root) root->print();
	}
};



Fenv tr;
vector<pair<int, int>> vec;
int n, B, C;
vector<int> nextMn;

signed main()
{
	cin >> n >> B >> C;
	vec.resize(n);
	nextMn.resize(n);
	For(i, n)
	{
		cin >> vec[i].first >> vec[i].second;
	}

	int j = n - 1;
	For4(i, n - 1, 0, -1)
	{
		while (vec[j].first - vec[i].first > C)
		{
			tr.erase(make_pair(vec[j].second, j));
			j--;
		}
		nextMn[i] = tr.getInd(vec[i].second);
		
		tr.add(vec[i].second, i);
	}

	int Benz = 0;
	int i = 0;
	while(i < n)
	{
		int nextInd = nextMn[i];
		if (nextInd == INF)
		{
			if (B >= vec[i].second * (C - Benz))
			{
				B -= vec[i].second * (C - Benz);
				Benz = C;
			}
			else
			{
				Benz += B / (vec[i].second);
				B = 0;
				break;
			}
			
			if (i == n - 1 || Benz < vec[i + 1].first - vec[i].first)
				break;
			Benz -= vec[i + 1].first - vec[i].first;
			i++;
		}
		else
		{
			if (Benz >= vec[nextInd].first - vec[i].first)
			{
				//B -= (vec[nextInd].first - vec[i].first) * vec[i].second;
				Benz -= (vec[nextInd].first - vec[i].first);
				i = nextInd;
			}
			else
			{
				if (B >= (vec[nextInd].first - vec[i].first - Benz) * vec[i].second)
				{
					B -= (vec[nextInd].first - vec[i].first - Benz) * vec[i].second;
					Benz = 0;
					i = nextInd;
				}
				else
				{
					Benz += B / vec[i].second;
					B = 0;
					break;
				}
			}
		}
	}
	cout << vec[i].first + Benz;
}
