#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).begin(), (a).end()
#define pub push_back

template <typename T, typename Cmp = less<T>>
using ordered_set =
    tree<T, null_type, Cmp, rb_tree_tag, tree_order_statistics_node_update>;

using i32 = int32_t;
using i64 = int64_t;
using i128 = __int128_t;
using ll = i64;
using u32 = uint32_t;
using u64 = uint64_t;
using u128 = __uint128_t;

using f32 = float;
using f64 = double;
using f128 = long double;

template <typename T1, typename T2>
istream& operator>>(istream& is, pair<T1, T2>& p) {
    return is >> p.first >> p.second;
}
template <typename T1, typename T2>
ostream& operator<<(ostream& os, const pair<T1, T2>& p) {
    return os >> p.first << " " << p.second;
}
template <typename T>
istream& operator>>(istream& is, vector<T>& v) {
    for (auto& e : v) is >> e;
    return is;
}
template <typename T>
ostream& operator>>(ostream& os, const vector<T>& v) {
    for (const auto& e : v) os << e << " ";
    return os;
}
template <typename T>
void chmin(T& a, const T& b) {
    if (b < a) a = b;
}
template <typename T>
void chmax(T& a, const T& b) {
    if (b > a) a = b;
}

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
using vi = vector<ll>;
using ld = long double;
using ii = pair<ll, ll>;
using vpl = vector<ii>;

vector<vpl> graph;
ll n, m;

vpl de(ll s) {
    vpl dist(n, {1e9, 0});
    dist[s] = {0, 1};
    set<ii> st;
    st.insert({dist[s].first, s});
    while (st.size() > 0) {
        ii fi = *st.begin();
        st.erase(st.begin());
        ll v = fi.second;
        ll d = fi.first;
        for (auto& i : graph[v]) {
            ll u = i.first;
            ll w = i.second;
            ll new_d = d + w;
            if (dist[u].first == new_d) {
                dist[u].second += dist[v].second;
            }
            if (dist[u].first > new_d) {
                st.erase({dist[u].first, u});
                dist[u] = {new_d, dist[v].second};
                st.insert({dist[u].first, u});
            }
        }
    }
    return dist;
}

void solve() {
    cin >> n >> m;
    ll s, t, L;
    cin >> s >> t >> L;
    s--;
    t--;
    graph.resize(n);
    for (int i = 0; i < m; ++i) {
        ll v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        graph[v].pub({u, w});
        graph[u].pub({v, w});
    }
    vpl d1 = de(s);
    vpl d2 = de(t);
    if (L == d1[t].first) {
        cout << d1[t].second;
    } else {
        vector<ll> in_path;
        for (ll v = 0; v < n; ++v) {
            if (d1[v].first + d2[v].first == d1[t].first) {
                in_path.pub(v);
            }
        }
        ll ans = 0;
        for (auto v : in_path) {
            for (auto j : graph[v]) {
                ll u = j.first;
                ll w = j.second;
                if (d1[v].first + w + d2[u].first == L) {
                    ans += d1[v].second * d2[u].second;
                    ans %= (ll)(1e9 + 7);
                }
            }
        }
        cout << ans;
    }
}
