#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).begin(), (a).end()
#define pub push_back

template <typename T, typename Cmp = less<T>>
using ordered_set =
    tree<T, null_type, Cmp, rb_tree_tag, tree_order_statistics_node_update>;

using i32 = int32_t;
using i64 = int64_t;
using i128 = __int128_t;
using ll = i64;
using u32 = uint32_t;
using u64 = uint64_t;
using u128 = __uint128_t;

using f32 = float;
using f64 = double;
using f128 = long double;

template <typename T1, typename T2>
istream& operator>>(istream& is, pair<T1, T2>& p) {
    return is >> p.first >> p.second;
}
template <typename T1, typename T2>
ostream& operator<<(ostream& os, const pair<T1, T2>& p) {
    return os >> p.first << " " << p.second;
}
template <typename T>
istream& operator>>(istream& is, vector<T>& v) {
    for (auto& e : v) is >> e;
    return is;
}
template <typename T>
ostream& operator<<(ostream& os, const vector<T>& v) {
    for (const auto& e : v) os << e << " ";
    return os;
}
template <typename T>
void chmin(T& a, const T& b) {
    if (b < a) a = b;
}
template <typename T>
void chmax(T& a, const T& b) {
    if (b > a) a = b;
}

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
using vi = vector<ll>;
using ld = long double;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vc = vector<char>;
using vvc = vector<vc>;
using vvi = vector<vi>;

vi used;
vvi gr;
ll color = 1;
vvc a;

void dfs(ll v) {
    used[v] = color;
    for (auto u : gr[v]) {
        if (used[u]) continue;
        dfs(u);
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    a.resize(n, vc(m));
    cin >> a;

    used.resize(n * m);
    gr.resize(n * m);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            auto check = [&](ll x, ll y) {
                if (0 <= x && x < n && 0 <= y && y < m && a[i][j] == a[x][y]) {
                    gr[i * m + j].emplace_back(x * m + y);
                }
            };

            check(i, j + 1);
            check(i, j - 1);
            check(i + 1, j);
            check(i - 1, j);
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (used[i * m + j] == 0) {
                dfs(i * m + j);
                color += 1;
            }
        }
    }

    ll lake_color = 1;
    for (;; ++lake_color) {
        bool ok = true;
        for (int i = 0; i < n && ok; ++i) {
            if (used[i * m + 0] == lake_color ||
                used[i * m + m - 1] == lake_color)
                ok = false;
        }
        for (int j = 0; j < m && ok; ++j) {
            if (used[0 * m + j] == lake_color ||
                used[(n - 1) * m + j] == lake_color)
                ok = false;
        }
        for (int i = 0; i < n && ok; ++i) {
            for (int j = 0; j < m && ok; ++j) {
                if (used[i * m + j] == lake_color && a[i][j] == '#') ok = false;
            }
        }
        if (ok) break;
    }

    ii L{-1, -1}, R{-1, -1}, T{-1, -1}, B{-1, -1};
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (used[i * m + j] == lake_color) {
                if (T.first == -1) {
                    T = {i, j};
                }
                if (L.first == -1) {
                    L = {i, j};
                }
                if (B.first == -1) {
                    B = {i, j};
                }
                if (R.first == -1) {
                    R = {i, j};
                }
                if (i < T.first) T = {i, j};
                if (j < L.second) L = {i, j};
                if (i > B.first) B = {i, j};
                if (j > R.second) R = {i, j};
            }
        }
    }

    // assert #
    T.first -= 1;
    B.first += 1;
    L.second -= 1;
    R.second += 1;

    vvc ans(n, vc(m, '.'));

    used.assign(n * m, 0);
    vi par(n * m, -1);
    deque<ll> q;
    q.emplace_front(T.first * m + T.second);
    used[q.front()] = true;
    while (!q.empty()) {
        ll v = q.back();
        q.pop_back();

        for (auto u : gr[v]) {
            ll i = u / m;
            ll j = u % m;
            if (i == L.first && j <= L.second) continue;

            if (!used[u]) {
                q.emplace_front(u);
                par[u] = v;
                used[u] = 1;
            }
        }
    }
    {
        ll v = B.first * m + B.second;
        while (v != -1) {
            ll i = v / m;
            ll j = v % m;
            ans[i][j] = '#';
            v = par[v];
        }
    }
    used.assign(n * m, 0);
    par.assign(n * m, -1);
    q.clear();
    q.emplace_front(T.first * m + T.second);
    used[q.front()] = true;
    while (!q.empty()) {
        ll v = q.back();
        q.pop_back();

        for (auto u : gr[v]) {
            ll i = u / m;
            ll j = u % m;
            if (i == R.first && j >= R.second) continue;

            if (!used[u]) {
                q.emplace_front(u);
                par[u] = v;
                used[u] = 1;
            }
        }
    }
    {
        ll v = B.first * m + B.second;
        while (v != -1) {
            ll i = v / m;
            ll j = v % m;
            ans[i][j] = '#';
            v = par[v];
        }
    }
    for (auto& e : ans) {
        for (auto& c : e) cout << c;
        cout << endl;
    }
}
