#include <bits/stdc++.h>
#define size(a) (int) a.size()
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;
using ld = long double;

const int md = (int) 1e9 + 7;
const ll inf = (ll) 1e18;

int n;
vector<vector<pair<int, ll>>> g;

pair<vector<ll>, vector<ll>> dijkstra(int s) {
  vector<ll> d(n, inf), cnt(n);
  d[s] = 0;
  cnt[s] = 1;
  priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> que;
  que.emplace(d[s], s);
  vector<int> used(n);
  while (!que.empty()) {
    auto [dv, v] = que.top();
    que.pop();
    if (used[v]) {
      continue;
    }
    used[v] = 1;
    for (auto [u, w] : g[v]) {
      if (d[u] > dv + w) {
        d[u] = dv + w;
        que.emplace(d[u], u);
        cnt[u] = cnt[v];
      } else if (d[u] == dv + w) {
        cnt[u] += cnt[v];
        cnt[u] %= md;
      }
    }
  }
  return make_pair(d, cnt);
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int m;
  cin >> n >> m;
  g.resize(n);
  int s, t;
  ll L;
  cin >> s >> t >> L;
  --s, --t;
  for (int i = 0; i < m; ++i) {
    int x, y;
    ll z;
    cin >> x >> y >> z;
    --x, --y;
    g[x].emplace_back(y, z);
    g[y].emplace_back(x, z);
  }
  auto [ds, cnts] = dijkstra(s);
  auto [dt, cntt] = dijkstra(t);
  ll ans = 0;
  for (int v = 0; v < n; ++v) {
    if (v != t && ds[v] + dt[v] == ds[t]) {
      for (auto [u, w] : g[v]) {
        if (ds[v] + w + dt[u] == L) {
          ans += cnts[v] * cntt[u];
          ans %= md;
        }
      }
    }
  }
  cout << ans;
  return 0;
}